;
; AutoIt Version: 3.0
; Language:       English
; Platform:       Win9x/NT
; Author:         Michael W. Bayley         
;
; Script Function:
;   Import MSIE Favorites

#include <Constants.au3>
#include <GUIConstants.au3>

#include "TrayUrlDefs.au3"
#include "TrayUrlIniFunc.au3"

;
; Global values
;

; Title Information
$TitleBar = "TrayURL MSIE Favorites Importer Version 2.0, (c) 2007 Michael W. Bayley"
$TitleBar2 = "TrayURL MSIE Favorites Importer"

; URL Entry Values
$Categories = 0
$Items = 0
$Index = 0
$Index2 = 0
$NotDone = 0
$Dir = ""
$File = ""
$Attr = ""
$Cat = ""
$Name = ""
$Url = ""
$Text = ""
$Counter = 0
$Perc = 0
$FullAction = ""
$FullActionDiscardAll = "DISCARDALL"
$FullActionDiscard = "DISCARD"
$FullActionRedirect = "REDIRECT"
$FullActionRedirectAll = "REDIRECTALL"

$CATMAX = $CatDefaultMax
$ITEMMAX = $UrlDefaultMax

; MSIE Favorites Values
$FavoritesFolder = ""
$FavoritesDirs = 0
$FavoritesFiles = 0
$FavoritesOvers = 0
$FavoritesLargest = 0
$FavoritesList = ""
$FavoritesExported = 0

$FavoritesCat = "IE"
$FavoritesExt = ".url"
$FavoritesSection = "InternetShortcut"
$FavoritesKey = "URL"

; Dialog Values
$TextSelect1 = "You can elect to import Microsoft Internet Explorer Favorites "
$TextSelect1 = $TextSelect1 & "from either " & Chr(34) & "All Users" & Chr(34)
$TextSelect1 = $TextSelect1 & " or from the current user.  If you select the "
$TextSelect1 = $TextSelect1 & "custom option, then you can select the base "
$TextSelect1 = $TextSelect1 & "folder to import Favorites from.  Please select "
$TextSelect1 = $TextSelect1 & "which option to import from."
$TextUser = "Current User:"
$TextCommon = "All Users"
$TextUser = "Current User"
$TextCustom = "Custom"
$TextCancel = "Cancel"

$TextCat1 = "CATEGORY ALREADY EXISTS!"
$TextCat2 = "Current name:"
$TextCat3 = "New folder name:"
$TextCat4 = "Do you wish to rename the category or append the bookmarks to the existing category?"
$TextRename = "Rename"
$TextAppend = "Append"

$TextFull1a = "OUT OF CATEGORIES!"
$TextFull1b = "CATEGORY FULL!"
$TextSelect2 = "You can select the " & Chr(34) & "Export" & Chr(34) & " option "
$TextSelect2 = $TextSelect2 & "and send the URL entry to a Favorites folder named "
$TextSelect2 = $TextSelect2 & Chr(34) & $FavoritesCat & Chr(34) & "off of the program directory, "
$TextSelect2 = $TextSelect2 & "you can select " & Chr(34) & "Export All" & Chr(34) & " "
$TextSelect2 = $TextSelect2 & "send all remaining entries in that category to the special "
$TextSelect2 = $TextSelect2 & "Favorites folder, you can select " & Chr(34) & "Discard" & Chr(34)
$TextSelect2 = $TextSelect2 & " the current URL entry, you can select " & Chr(34) & "Discard All"
$TextSelect2 = $TextSelect2 & Chr(34) & " and discard the remaining URL entries in that category, "
$TextSelect2 = $TextSelect2 & "or you can edit the category name above and redirect the URL "
$TextSelect2 = $TextSelect2 & "entries to a new category."
$TextSelect3 = "You can select the " & Chr(34) & "Export" & Chr(34) & " option "
$TextSelect3 = $TextSelect3 & "and send the URL entry to a Favorites folder named "
$TextSelect3 = $TextSelect3 & Chr(34) & $FavoritesCat & Chr(34) & "off of the program directory, "
$TextSelect3 = $TextSelect3 & "you can select " & Chr(34) & "Export All" & Chr(34) & " "
$TextSelect3 = $TextSelect3 & "send all remaining entries in that category to the special "
$TextSelect3 = $TextSelect3 & "Favorites folder, you can select " & Chr(34) & "Discard" & Chr(34)
$TextSelect3 = $TextSelect3 & " the current URL entry, or you can select " & Chr(34) & "Discard All"
$TextSelect3 = $TextSelect3 & Chr(34) & " and discard the remaining URL entries in that category."
$TextFull2 = "Current name:"
$TextFull3 = "New folder name:"
$TextFull4 = "Do you wish to rename the category or append the bookmarks to the existing category?"
$TextNew = "New Category"
$TextExport = "Export"
$TextExportAll = "Export All"
$TextDiscard = "Discard"
$TextDiscardAll = "Discard All"

$TextUrl1 = "FAVORITE ALREADY EXISTS!"
$TextUrl2 = "Favorite folder:"
$TextUrl3 = "Current name:"
$TextUrl4 = "New name:"
$TextUrl5 = "Do you wish to rename the URL entry, overwrite it, export it to temporary location, or discard it?"
$TextOverwrite = "Overwrite"

$TextProgress = "Processing MSIE Favorites..."
$FullDialogRetry = 0
$FullDialogRedirect = 1
$FullDialogRedirectAll = 2
$FullDialogDiscard = 3
$FullDialogDiscardAll = 4


;
; Main Code
;
; Entry:       <None>
; Return:      0 - No errors
;              1 - Fatal error encountered
; Procedure:   1. If command line parameter then message & exit.
;              2. If ini file not found, then create it.
;              3. Verify it is a TrayURL profile, error if not.
;              4. Get user to pick User Favorite or Common Favorites.
;              5. Compute number of categories and files.
;              6. Import the Favorites.
;              7. Adjust menu size limits.
;              7. Exit all done.
;

; 1. If command line parameter then message & exit.

$msg = "This program will import Microsoft Internet Explorer Favorites into TrayURL.  If no command" & @CRLF
$msg = $msg & "parameters are supplied then the Favorites will be imported into the default profile, otherwise"  & @CRLF
$msg = $msg & "the profile specified on the command line will be used.  You will be given the choice of" & @CRLF
$msg = $msg & "importing the Favorites from " & Chr(34) & "All Users" & Chr(34) & " or those from the current user." & @CRLF & @CRLF
$msg = $msg & "In all instances the profile file must exist in the same directory as the program." & @CRLF & @CRLF
MsgBox(0, $TitleBar, $msg)

If $CmdLine[0] > 1 Then
   MsgBox(0, $TitleBar, "Error - Illegal number of command line arguments!")
   Exit(1)
ElseIf $CmdLine[0] == 1 Then
   $IniFile = @ScriptDir
   If StringRight($IniFile, 1) == "\" Then
      $IniFile = $IniFile & $CmdLine[1] & ".ini"
   Else
      $IniFile = $IniFile & "\" & $CmdLine[1] & ".ini"
   EndIf
EndIf


; 2. If ini file not found, then create it.
If FileExists($IniFile) <> 1 Then
   $msg = "Profile " & $IniFile & " not found!" & @CRLF & @CRLF
   $msg = $msg & "Would you like to create it?" & @CRLF & @CRLF
   If MsgBox(4, $TitleBar, $msg) <> 6 Then Exit(0)
   
   $msg = FileOpen($IniFile, 10)
   If $msg == -1 Then
      MsgBox(0, $TitleBar, "Fatal Error - Unable to create " & $IniFile & "!")
      Exit(1)
   EndIf
   FileClose($msg)

   IniWrite($IniFile, $IniProgram, $IniTag, $ProgramID)
   IniWrite($IniFile, $IniProgram, $IniMajor, $ProgramMajor)
   IniWrite($IniFile, $IniProgram, $IniMinor, $ProgramMinor)
   IniWrite($IniFile, $IniProgram, $IniBrowserType, $IniBrowserTypeDefault)
   IniWrite($IniFile, $IniCatSection, $IniItems, 0)
   IniWrite($IniFile, $IniCatMain, $IniItems, 0)
EndIf


; 3. Verify it is a TrayURL profile, error if not.
$Tag = IniRead($IniFile, $IniProgram, $IniTag, "")
$Major = Number(IniRead($IniFile, $IniProgram, $IniMajor, 0))
$Minor = Number(IniRead($IniFile, $IniProgram, $IniMinor, 0))

If $Tag <> $ProgramID Then
   MsgBox(0, $TitleBar, "Error - Profile " & $IniFile & " does not appear to be valid!")
   Exit(1)   
EndIf

If $Major <> $ProgramMajor OR $Minor <> $ProgramMinor Then
   $msg = "WARNING! The profile appears to be from a different version of TrayURL." & @CRLF
   $msg = $msg & "Proceeding may produce unknown results." & @CRLF & @CRLF
   $msg = $msg & "Proceed anyway?" & @CRLF & @CRLF
   If MsgBox(260, $TitleBar, $msg) <> 6 Then Exit(0)
EndIf


; 4. Get user to pick User Favorite or Common Favorites.
$FavoritesFolder = FavoritesDialog()
If StringLen($FavoritesFolder) == 0 Then Exit(0)

; Pick import to category.
$msg = "Please select a base category to import to (leave blank "
$msg &= "to import to " & $IniCatMain & "):"
While 1
   $FavoritesCat = InputBox($TitleBar2, $msg, $FavoritesCat, "", 300, 140)
   If @error Then Exit(0)
   If StringInStr($FavoritesCat, "[") OR StringInStr($FavoritesCat, "]") Then
      MsgBox(0, $TitleBar, "Error - Category may not contain '[' or ']' characters")
   Else
      ExitLoop
   EndIf
WEnd 


; 5. Compute number of categories and files.
$FavoritesDirs = 0
$FavoritesFiles = 0
$FavoritesOvers = 0
$FavoritesLargest = 0
$FavoritesList = ""
If DirSearchStats("", $FavoritesExt, $UrlDefaultMax) Then Exit(1)

$msg = "FAVORITES STATISTICS FOR " & Chr(34) & $FavoritesFolder & Chr(34) & @CRLF & @CRLF
$msg = $msg & @TAB & "      Total Favorites Folders = " & $FavoritesDirs & @CRLF
$msg = $msg & @TAB & "      Total Favorites Entries = " & $FavoritesFiles & @CRLF
$msg = $msg & @TAB & "      Total Oversized Folders = " & $FavoritesOvers & @CRLF
$msg = $msg & @TAB & "      Largest Folder (# of entries) = " & $FavoritesLargest & @CRLF & @CRLF

If $FavoritesOvers Then
   $msg = $msg & "WARNING!  There are " & $FavoritesOvers & " folder(s) with over the maximum number" & @CRLF
   $msg = $msg & "of bookmarks allowed.  These folders will be split into multiple" & @CRLF
   $msg = $msg & "categories as needed." & @CRLF & @CRLF
EndIf
$msg = $msg & "Proceed with the import?" & @CRLF
If MsgBox(4, $TitleBar2, $msg) <> 6 Then Exit(0)


; 6. Import the Favorites.
$Counter = 0
ProgressOn($titleBar2, "", $TextProgress, 20, 20)
While StringLen($FavoritesList)
   ; Get next directory.
   $pos = StringInStr($FavoritesList, Chr(1), 1, -1)
   If $pos Then
      $Dir = StringMid($FavoritesList, $pos + 1)
      $FavoritesList = StringLeft($FavoritesList, $pos - 1)
   Else
      $Dir = $FavoritesList
      $FavoritesList = ""
   EndIf

   ; Start the directory search.
   If $Dir = "." Then $Dir = ""
   $Text = DirAppend($FavoritesFolder, $Dir)
   $Text = DirAppend($Text, "*" & $FavoritesExt)
   $handle = FileFindFirstFile($Text)
   If $handle <> -1 OR @error <> 1 Then
      ; Build Category name.
      $Cat = DirAppend($FavoritesCat, $dir)
      While 1
         $pos = StringInStr($Cat, "/")
         If $pos Then
            $Cat = StringLeft($Cat, $pos - 1) & "-" & StringMid($Cat, $pos + 1)
         Else
            ExitLoop
         EndIf
      WEnd
      While 1
         $pos = StringInStr($Cat, "\")
         If $pos Then
            $Cat = StringLeft($Cat, $pos - 1) & "/" & StringMid($Cat, $pos + 1)
         Else
            ExitLoop
         EndIf
      WEnd
      While 1
         $pos = StringInStr($Cat, "[")
         If $pos Then
            $Cat = StringLeft($Cat, $pos - 1) & "{" & StringMid($Cat, $pos + 1)
         Else
            ExitLoop
         EndIf
      WEnd
      While 1
         $pos = StringInStr($Cat, "]")
         If $pos Then
            $Cat = StringLeft($Cat, $pos - 1) & "}" & StringMid($Cat, $pos + 1)
         Else
            ExitLoop
         EndIf
      WEnd

      ; Create the Category.
      $Cat = AddCategory($Cat)
      If $FullAction <> $FullActionDiscardAll AND $FullAction <> $FullActionRedirectAll Then
         $FullAction = ""
      EndIf

      ; Add the URL entries.   
      While 1
         $File = FileFindNextFile($handle)
         If StringLen($File) Then
            $Attr = FileGetAttrib(DirAppend(DirAppend($FavoritesFolder, $Dir), $File))
            If StringInStr(StringUpper($Attr), "D") == 0 Then
               $Url = IniRead(DirAppend(DirAppend($FavoritesFolder, $Dir), $File), $FavoritesSection, $FavoritesKey, "")
               If StringLen($Url) Then
                  $Counter += 1
                  $Perc = ($Counter * 100) / $FavoritesFiles
                  ProgressSet($Perc, "Category: " & $Cat, $TextProgress)
                  $Name = StringLeft($File, StringLen($File) - StringLen($FavoritesExt))
                  $Cat = AddUrlEntry($Cat, $Name, $Url)
               EndIf
            EndIf
         Else
            ExitLoop
         EndIf
      WEnd
      FileClose($handle)
   Else
      MsgBox(0, $TitleBar, "Error - Unable to open search handle for " & $Text)
      Exit(1)      
   EndIf
WEnd
ProgressOff()


; 7. Adjust menu size limits.
$Items = Number(IniRead($IniFile, $IniCatSection, $IniItems, 0))
$Categories = Number(IniRead($IniFile, $IniProgram, $IniCatMax, 0))
If $Items > $Categories Then
   If $Items > $CatDefaultMax Then $Items = $CatDefaultMax
   $Items = ($Items + 4) - Mod($Items + 4, 5)
   If IniWrite($IniFile, $IniProgram, $IniCatMax, $Items) <> 1 Then
      MsgBox(0, $TitleBar, "Error - Failure rewriting category maximum to INI file!")
   EndIf
EndIf

$Items = Number(IniRead($IniFile, $IniProgram, $IniUrlMax, 0))
If $FavoritesLargest > $Items Then
   If $FavoritesLargest > $UrlDefaultMax Then $FavoritesLargest = $UrlDefaultMax
   $FavoritesLargest = ($FavoritesLargest + 4) - Mod($FavoritesLargest + 4, 5)
   If IniWrite($IniFile, $IniProgram, $IniUrlMax, $FavoritesLargest) <> 1 Then
      MsgBox(0, $TitleBar, "Error - Failure rewriting URL entry maximum to INI file!")
   EndIf
EndIf 


; 8. Exit all done.
$msg = "Process Complete!" & @CRLF
If $FavoritesExported Then
   $msg = $msg & @CRLF
   $msg = $msg & "NOTICE: During the import process you elected to export one or more URL entries.  The" & @CRLF
   $msg = $msg & "entrie(s) have been saved in Microsoft Internet Explorer Favorites format in a directory" & @CRLF
   $msg = $msg & "named " & Chr(34) & "IE" & Chr(34) & "which was created here in the local program directory!" & @CRLF & @CRLF
EndIf

MsgBox(0, $TitleBar, $msg)
Exit(0)


;
; User Defined Functions
; Main Support Functions
;

;
; AddCategory($cat)
; Inputs:         $cat        Category to add
; Returns:        Category in use
;                 NULL if failure
; Procedure:      1. Skip if discarding.
;                 2. Skip if redirecting.
;                 3. Get user input if category exists.
;                 4. Add category if needed.
;                 5. If full then get user to decide on action.
;                 6. Return new category.
;
Func  AddCategory($cat)
   Local    $items, $index, $newcat, $cat2, $ret, $ret2

   ; 1. Skip if discarding.
   If $FullAction == $FullActionDiscardAll OR $FullAction == $FullActionDiscard Then
      Return($cat)
   EndIf


   ; 2. Skip if redirecting.
   If $FullAction == $FullActionRedirectAll OR $FullAction == $FullACtionRedirect Then
      Return($cat)
   EndIf


    ; 3. Get user input if category exists.
   If StringLen($cat) Then
      $items = Number(IniRead($IniFile, $IniCatSection, $IniItems, 0))
      $index = 1
      $newcat = $cat
      While $index <= $items
         $cat2 = IniRead($IniFile, $IniCatSection, $IniItem & $index, "")
         If StringLen($cat2) Then
            If $newcat == $cat2 Then
               $cat2 = CategoryDialog($newcat)
               If StringLen($cat2) == 0 Then
                  ExitLoop
               Else
                  $newcat = $cat2
                  $index = 0
               EndIf
            EndIf
         EndIf
         $index = $index + 1
      WEnd
   Else
      $newcat = $IniCatMain
      $cat2 = ""
   EndIf
   
   
   ; 4. Add category if needed.
   If StringLen($cat2) Then
      $cat2 = $newcat
      While 1
         $ret = AddCatToIni($TitleBar, $cat2, 0)

         ; 5. If full then get user to decide on action.
         If $ret == -1 Then
            $cats = IniRead($IniFile, $IniCatSection, $IniItems, 0)
            If $cats == $CATMAX Then
               $cat2 = CategoryFullDialog($cat2, 1)
               $ret2 = 1
            Else
               $cat2 = CategoryFullDialog($cat2, 0)
               $ret2 = 0
            EndIf
            
            If @error == $FullDialogRedirect Then
               ExitLoop
            ElseIf @error == $FullDialogRedirectAll Then
               If $ret2 Then
                  $FullAction = $FullActionRedirectAll
               Else
                  $FullAction = $FullActionRedirect
               EndIf
               ExitLoop
            ElseIf @error == $FullDialogDiscard Then
               ExitLoop
            ElseIf @error == $FullDialogDiscardAll Then
               If $ret2 Then
                  $FullAction = $FullActionDiscardAll
               Else
                  $FullAction = $FullActionDiscard
               EndIf
               ExitLoop
            EndIf
         EndIf
 
 
         If $ret == 1 Then
            $cat2 = $cat
            ExitLoop
         Else
            ExitLoop
         EndIf
      WEnd
      $newcat = $cat2
   EndIf


   ; 6. Return new category.
   Return($newcat)
EndFunc


;
; AddUrlEntry($cat, $name, $url)
; Inputs:         $cat        Category to add to
;                 $name       Entry name to add
;                 $url        URL to add
; Returns:        Category in use
;                 NULL if failure
; Procedure:      1. Skip if discarding.
;                 2. Write to Favorite if redirecting.
;                 3. Attempt to add entry.
;                 4. If full then get user to decide on action.
;                 5. If abort overwrite then get user to select new category.
;                 6. Return category.
;
Func  AddUrlEntry($cat, $name, $url)
   Local    $ret, $ret2, $cats, $cat2, $warning

   ; 1. Skip if discarding.
   If $FullAction == $FullActionDiscardAll OR $FullAction == $FullActionDiscard Then
      Return($cat)
   EndIf


   ; 2. Write to favorite if redirecting.
   If $FullAction == $FullActionRedirectAll OR $FullAction == $FullACtionRedirect Then
      $FavoritesExported = 1
      WriteFavorite($cat, $name, $url)
      Return($cat)
   EndIf


   ; 3. Attempt to add entry.
   $cat2 = $cat
   $warning = 1
   While 1
      $ret = AddEntryToIni($TitleBar, $cat2, $name, $url, "", "", 0, "", $warning)
      If $ret == 1 Then ExitLoop
      $warning = 1

      ; 4. If full then get user to decide on action.
      If $ret == -1 Then
         $cats = IniRead($IniFile, $IniCatSection, $IniItems, 0)
         If $cats == $CATMAX Then
            $cat2 = CategoryFullDialog($cat2, 1)
            $ret2 = 1
         Else
            $cat2 = CategoryFullDialog($cat2, 0)
            $ret2 = 0
         EndIf
            
         If @error == $FullDialogRetry Then
            $cat2 = AddCategory($cat2)
         ElseIf @error == $FullDialogRedirect Then
            $FavoritesExported = 1
            WriteFavorite($cat2, $name, $url)
            ExitLoop
         ElseIf @error == $FullDialogRedirectAll Then
            $FavoritesExported = 1
            WriteFavorite($cat2, $name, $url)
            If $ret2 Then
               $FullAction = $FullActionRedirectAll
            Else
               $FullAction = $FullActionRedirect
            EndIf
            ExitLoop
         ElseIf @error == $FullDialogDiscard Then
            ExitLoop
         ElseIf @error == $FullDialogDiscardAll Then
            If $ret2 Then
               $FullAction = $FullActionDiscardAll
            Else
               $FullAction = $FullActionDiscard
            EndIf
            ExitLoop
         EndIf
      EndIf


      ; 5. If abort overwrite then get user to select new category.
      If $ret == 0 Then
         $name2 = NameDialog($cat2, $name)

         If @error == $FullDialogRetry Then
            $warning = 0
            $name = $name2
         ElseIf @error == $FullDialogRedirect Then
            $FavoritesExported = 1
            WriteFavorite($cat2, $name, $url)
            ExitLoop
         ElseIf @error == $FullDialogDiscard Then
            ExitLoop
         EndIf
      EndIf
   WEnd


   ; 6. Return category. 
   Return($cat2)
EndFunc

;
; User Defined Functions
; Dialog Functions
;

;
; FavoritesDialog()
; Inputs:         <None>
; Returns:        Path to Favorites folder to use
;                 NULL if user aborts
; Procedure:      1. Get Common Favorites.
;                 2. Get User Favorites. 
;                 3. Display dialog.
;                 4, Get user response.
;                 5. Return data.
;
Func  FavoritesDialog()
   Local    $dlg
   Local    $edit1, $button1, $button2, $button3, $button4
   Local    $notDone, $notDone2, $msg
   Local    $common, $user

   ; 1. Get Common Favorites.
   $common = @FavoritesCommonDir


   ; 2. Get User Favorites.
   $user = @FavoritesDir 


   ; 3. Display dialog.
   $dlg = GUICreate($TitleBar2, 370, 184)
   GUICtrlCreateLabel($TextSelect1, 25, 12, 320, 60)
   GUICtrlCreateLabel($TextUser, 98, 90, 80, 20)
   $edit1 = GUICtrlCreateInput(@UserName, 174, 88, 100, 20)
   $button1 = GUICtrlCreateButton($TextCommon, 10, 132, 80, 30)
   $button2 = GUICtrlCreateButton($TextUser, 100, 132, 80, 30)
   $button3 = GUICtrlCreateButton($TextCustom, 190, 132, 80, 30)
   $button4 = GUICtrlCreateButton($TextCancel, 280, 132, 80, 30)
   GUICtrlSetState($edit1, $GUI_DISABLE)
   GUISetState(@SW_SHOW, $dlg)


   ; 4. Get user input.
   $notDone = 1
   While $notDone
      $msg = GUIGetMsg($dlg)
      Select
         Case $msg == $GUI_EVENT_CLOSE
            $msg = ""
            $notDone = 0
         Case $msg == $button1
            $msg = $user
            $notDone = 0
         Case $msg == $button2
            $msg = $user
            $notDone = 0
         Case $msg == $button3
            GUISetState(@SW_DISABLE, $dlg)
            If StringInStr(@UserProfileDir, "\Profiles\") == 0 Then
               $msg = @WindowsDir
            Else
               $msg = @UserProfileDir
               $msg = StringLeft($msg, StringInStr($msg, "\", 1, -1) - 1)
               If StringLen($msg) ==2 AND StringRight($msg, 1) == ":" Then
                  $msg = $msg & "\"
               EndIf
            EndIf
            $msg = FileSelectFolder($TitleBar2, "", 0, $msg)
            GUISetState(@SW_ENABLE, $dlg)
            GUISetState(@SW_HIDE, $dlg)
            GUISetState(@SW_SHOW, $dlg)
            If StringLen($msg) Then $notDone = 0
         Case $msg == $button4
            $msg = ""
            $notDone = 0
      EndSelect
   WEnd


   ; 5. Return data.
   GUIDelete($dlg)
   Return($msg)
EndFunc


;
; CategoryDialog($cat)
; Inputs:         $cat     Category in conflict
; Returns:        Path to folder to use
;                 NULL if use same folder
; Procedure:      1. Display dialog
;                 2. Get user input. 
;                 3. Return the data.
;
Func  CategoryDialog($cat)
   Local    $dlg
   Local    $edit1, $edit2, $button1, $button2
   Local    $notDone, $msg, $newcat

   ; 1. Display dialog.
   $dlg = GUICreate($TitleBar2, 360, 218)
   GUICtrlCreateLabel($TextCat1, 105, 16, 260, 20)
   GUICtrlCreateLabel($TextCat2, 40, 50, 100, 20)
   $edit1 = GUICtrlCreateInput($cat, 135, 48, 180, 20)
   GUICtrlCreateLabel($TextCat3, 40, 80, 100, 20)
   $edit2 = GUICtrlCreateInput($cat, 135, 78, 180, 20)
   GUICtrlCreateLabel($TextCat4, 30, 120, 300, 40)
   $button1 = GUICtrlCreateButton($TextRename, 100, 168, 80, 30)
   $button2 = GUICtrlCreateButton($TextAppend, 200, 168, 80, 30)
   GUICtrlSetState($edit1, $GUI_DISABLE)
   GUICtrlSetState($button1, $GUI_DEFBUTTON)
   GUISetState(@SW_SHOW, $dlg)


   ; 2. Get user input.
   $notDone = 1
   While $notDone
      $msg = GUIGetMsg($dlg)
      Select
         Case $msg == $button1
            $newcat = GUICtrlRead($edit2)
            If StringInStr($newcat, "[") OR StringInStr($newcat, "]") Then
               MsgBox(0, $TitleBar, "Error - Category may not contain '[' or ']' characters")
               GUICtrlSetState($edit2, $GUI_FOCUS)
            Else
               $notDone = 0
            EndIf
         Case $msg == $button2
            $newcat = ""
            $notDone = 0
      EndSelect
   WEnd


   ; 3. Return the data.
   GUIDelete($dlg)
   Return($newcat)
EndFunc


;
; CategoryFullDialog($cat, $flag)
; Inputs:         $cat     Category in conflict
;                 $flag    Out of categories flag
; Returns:        New category
; Procedure:      1. Display dialog
;                 2. Get user input. 
;                 3. Return the data.
;
Func  CategoryFullDialog($cat, $flag)
   Local    $dlg
   Local    $edit1, $edit2, $button1, $button2, $button3, $button4, $button5
   Local    $notDone, $msg, $newcat, $ret

   ; 1. Display dialog.
   If $flag Then
      $dlg = GUICreate($TitleBar2, 370, 291)
      GUICtrlCreateLabel($TextFull1a, 130, 13, 120, 20)
      GUICtrlCreateLabel($TextSelect3, 30, 36, 310, 90)
   Else
      $dlg = GUICreate($TitleBar2, 370, 331)
      GUICtrlCreateLabel($TextFull1b, 135, 13, 120, 20)
      GUICtrlCreateLabel($TextSelect2, 30, 36, 310, 90)
   EndIf
   GUICtrlCreateLabel($TextCat2, 45, 140, 100, 20)
   $edit1 = GUICtrlCreateInput($cat, 140, 139, 180, 20)
   GUICtrlCreateLabel($TextCat3, 45, 170, 100, 20)
   $edit2 = GUICtrlCreateInput($cat, 140, 168, 180, 20)
   GUICtrlCreateLabel($TextCat4, 40, 205, 300, 40)
   If $flag  Then
      $button1 = -1
   Else
      $button1 = GUICtrlCreateButton($TextNew, 145, 290, 80, 30)
   EndIf
   $button2 = GUICtrlCreateButton($TextExport, 10, 245, 80, 30)
   $button3 = GUICtrlCreateButton($TextExportAll, 100, 245, 80, 30)
   $button4 = GUICtrlCreateButton($TextDiscard, 190, 245, 80, 30)
   $button5 = GUICtrlCreateButton($TextDiscardAll, 280, 245, 80, 30)
   GUICtrlSetState($edit1, $GUI_DISABLE)
   If $flag Then
      GUICtrlSetState($edit2, $GUI_DISABLE)
      GUICtrlSetState($button2, $GUI_DEFBUTTON)
   Else
      GUICtrlSetState($button1, $GUI_DEFBUTTON)
   EndIf
   GUISetState(@SW_SHOW, $dlg)


   ; 2. Get user input.
   $notDone = 1
   While $notDone
      $msg = GUIGetMsg($dlg)
      Select
         Case $msg == $button1
            $newcat = GUICtrlRead($edit2)
            If StringInStr($newcat, "[") OR StringInStr($newcat, "]") Then
               MsgBox(0, $TitleBar, "Error - Category may not contain '[' or ']' characters")
               GUISetState(@SW_ENABLE, $dlg)
               GUISetState(@SW_HIDE, $dlg)
               GUISetState(@SW_SHOW, $dlg)
               GUICtrlSetState($edit2, $GUI_FOCUS)
            ElseIf StringLen($newcat) Then
               $ret = $FullDialogRetry
               $notDone = 0
            Else
               GUISetState(@SW_DISABLED, $dlg)
               MsgBox(0, $TitleBar2, "Error - Blank category specified!")
               GUISetState(@SW_ENABLE, $dlg)
               GUISetState(@SW_HIDE, $dlg)
               GUISetState(@SW_SHOW, $dlg)
               GUICtrlSetState($edit2, $GUI_FOCUS)
            EndIf
         Case $msg == $button2
            $newcat = $cat
            $ret = $FullDialogRedirect
            $notDone = 0
         Case $msg == $button3
            $newcat = $cat
            $ret = $FullDialogRedirectAll
            $notDone = 0
         Case $msg == $button4
            $newcat = $cat
            $ret = $FullDialogDiscard
            $notDone = 0
         Case $msg == $button5
            $newcat = $cat
            $ret = $FullDialogDiscardAll
            $notDone = 0
      EndSelect
   WEnd


   ; 3. Return the data.
   GUIDelete($dlg)
   SetError($ret)
   Return($newcat)
EndFunc


;
; NameDialog($folder, $name)
; Inputs:         $folder  Folder containg URL in conflict
;                 $name    URL name in conflict
; Returns:        New name for Favorite file to use
;                 $name for overwrite
;                 @error = action
; Procedure:      1. Display dialog
;                 2. Get user input. 
;                 3. Return the data.
;
Func  NameDialog($folder, $name)
   Local    $dlg
   Local    $edit1, $edit2, $edit3
   Local    $button1, $button2, $button3, $button4
   Local    $notDone, $msg, $newname, $ret

   ; 1. Display dialog.
   $dlg = GUICreate($TitleBar2, 370, 248)
   GUICtrlCreateLabel($TextUrl1, 113, 16, 260, 20)
   GUICtrlCreateLabel($TextUrl2, 35, 50, 100, 20)
   $edit1 = GUICtrlCreateInput($folder, 125, 48, 210, 20)
   GUICtrlCreateLabel($TextUrl3, 35, 80, 100, 20)
   $edit2 = GUICtrlCreateInput($name, 125, 78, 210, 20)
   GUICtrlCreateLabel($TextUrl4, 35, 110, 100, 20)
   $edit3 = GUICtrlCreateInput($name, 125, 108, 210, 20)
   GUICtrlCreateLabel($TextUrl5, 35, 150, 310, 40)
   $button1 = GUICtrlCreateButton($TextRename, 10, 198, 80, 30)
   $button2 = GUICtrlCreateButton($TextOverwrite, 100, 198, 80, 30)
   $button3 = GUICtrlCreateButton($TextExport, 190, 198, 80, 30)
   $button4 = GUICtrlCreateButton($TextDiscard, 280, 198, 80, 30)
   GUICtrlSetState($edit1, $GUI_DISABLE)
   GUICtrlSetState($edit2, $GUI_DISABLE)
   GUICtrlSetState($button1, $GUI_DEFBUTTON)
   GUISetState(@SW_SHOW, $dlg)


   ; 2. Get user input.
   $notDone = 1
   While $notDone
      $msg = GUIGetMsg($dlg)
      Select
         Case $msg == $button1
            ; Rename entry
            $newname = GUICtrlRead($edit3)
            If StringLen($newname) == 0 Then
               GUISetState(@SW_DISABLED, $dlg)
               MsgBox(0, $TitleBar2, "Error - Blank entry specified!")
               GUISetState(@SW_ENABLE, $dlg)
               GUISetState(@SW_HIDE, $dlg)
               GUISetState(@SW_SHOW, $dlg)
               GUICtrlSetState($edit3, $GUI_FOCUS)
            Else
               $ret = $FullDialogRetry
               $notDone = 0
            EndIf
         Case $msg == $button2
            ; Overwrite
            $newname = $name
            $ret = $FullDialogRetry
            $notDone = 0
         Case $msg == $button3
            ; Export
            $newname = GUICtrlRead($edit3)
            $ret = $FullDialogRedirect
            $notDone = 0
         Case $msg == $button4
            ; Discard
            $newname = $name
            $ret = $FullDialogDiscard
            $notDone = 0
      EndSelect
   WEnd


   ; 3. Return data.
   GUIDelete($dlg)
   SetError($ret)
   Return($newname)
EndFunc


;
; WriteFavorite($folder, $name, $url)
; Inputs:         $folder  Path to favorite folder
;                 $name    Filename of URL
;                 $url     URL to write
; Returns:        0        All ok
;                 1        Write failure
; Procedure:      1. Create the file, error if fail.
;                 2. Write the URL, report if error.
;                 3. Exit all done.
;
Func  WriteFavorite($folder, $name, $url)
      Local    $handle
      Local    $base, $pos

      ; 1. Create the file, report if fail.
      $base = DirAppend(@ScriptDir, $folder)
      While 1
         $pos = StringInStr($base, "/")
         If $pos Then
            $base = StringLeft($base, $pos - 1) & "\" & StringMid($base, $pos + 1)
         Else
            ExitLoop
         EndIf
      WEnd

      $handle = FileOpen(DirAppend($base, $name), 10)
      If $handle == -1 Then
         MsgBox(0, $TitleBar, "Error - Failure creating Favorite " & Chr(34) & $name & Chr(34) & " in category folder " & $cat & "!")
         Return(1)
      EndIf
      FileClose($handle)
      
      
      ; 2. Write the URL, report if failure.
      If IniWrite(DirAppend($base, $name), $FavoritesSection, $FavoritesKey, $url) <> 1 Then
         MsgBox(0, $TitleBar, "Error - Failure writing Favorite " & Chr(34) & $name & Chr(34) & " in category folder " & $cat & "!")
         Return(1)
      EndIf
   
   
   ; 3. Rexit all done.
   Return(0)
EndFunc


;
; User Defined Functions
; Search Functions
;

;
; DirSearchStats($dir, $pattern, $max)
;
; Description:    Recursive search of $dir for files matching $pattern
; Inputs:         $dir     Directory string to search
;                 $pattern File pattern to search for
;                 $max     Max if exceded increments over count
;                 $FavoritesFolder contains base directory
; Returns:        0 if ok
;                 1 if error
;                 $FavoritesDirs incremented by 1 if dir contaisn files
;                 $FavoritesFiles incrmented by matching file count
;                 $FavoritesOvers incremnted if file count > max
;                 $FavoritesLargest replaced if file count is larger
;                 $FavoritesList appended dir name if files match
; Procedure:      1. Open the search, report if error.
;                 2. Perform the search.
;                 3. Return the data.
;
Func  DirSearchStats($dir, $pattern, $max)
   Local    $handle, $count, $dir2, $text, $attr
   
   ; 1. Open the search, report if error.
   $dir2 = DirAppend($favoritesFolder, $dir)
   $handle = FileFindFirstFile(DirAppend($dir2, "*.*"))
   If $handle == -1 Then
      If @error == 1 Then
         Return(0)
      Else
         MsgBox(0, $TitleBar, "Error - Can't open search for " & Chr(34) & DirAppend($dir2, $pattern) & Chr(34))
         Return(-1)
      EndIf
   EndIf


   ; 2. Perform the search.
   $count = 0
   While 1
      $text = FileFindNextFile($handle)
      If StringLen($text) == 0 Then
         ExitLoop
      Else
         $attr = StringUpper(FileGetAttrib(DirAppend($dir2, $text)))
         If StringInStr($attr, "D") Then
            If DirSearchStats(DirAppend($dir, $text), $pattern, $max) Then Return(0)
         Else
            If StringUpper(StringRight($text, StringLen($pattern))) == StringUpper($pattern) Then
               $count = $count + 1
            EndIf
         EndIf
      EndIf
   WEnd
   FileClose($handle)


   ; 3. Return the data.
   If $count > $FavoritesLargest Then $FavoritesLargest = $count
   If $count > $max Then $FavoritesOvers = $FavoritesOvers + 1
   If $count Then
      $FavoritesDirs = $FavoritesDirs + 1
      $FavoritesFiles = $FavoritesFiles + $count
      If StringLen($FavoritesList) Then $FavoritesList = $FavoritesList & Chr(1)
      If STringLen($dir) == 0 Then $FavoritesList = $FavoritesList & "."
      $FavoritesList = $FavoritesList & $dir
   EndIf
   Return(0)
EndFunc


;
; User Defined Functions
; Miscelaneous Functions
;

;
; DirAppend($dir, $file)
;
; Description:    Append the file string to the directory string.  Insert
;                 a "\" if needed.
; Inputs:         $dir     Directory string to append to
;                 $file    File string to append
; Procedure:      1. If directory is null then return file.
;                 2. If file is null then return directory.
;                 3. If directory ends in "\" then $dir + $file.
;                 4. Else $dir + "\" + $file.
;
Func  DirAppend($dir, $file)
   ; 1. If directory is null then return file.
   If StringLen($dir) == 0 Then
      Return($file)
   EndIf


   ; 2. If file is null then return directory.
   If StringLen($file) == 0 Then
      Return($dir)
   EndIf


   ; 3. If directory ends in "\" then $dir + $file.
   If StringRight($dir, 1) == "\" Then
      Return($dir & $file)
   EndIf

   
   ; 4. Else $dir + "\" + $file.
   Return($dir & "\" & $file)
EndFunc

