;
; AutoIt Version: 3.0
; Language:       English
; Platform:       Win9x/NT
; Author:         Michael W. Bayley
;
; Script Function:
;   TrayURL - Tray Based Bookmark Manager - Main Program

#include <Constants.au3>
#include <GUIConstants.au3>

#include "TrayUrlDefs.au3"
#include "TrayUrlIniFunc.au3"

#NoTrayIcon
Opt("TrayMenuMode",1)
AutoItSetOption("GUIDataSeparatorChar", $RECSEP)


;
; Global values
;

; Title Information
$TitleBar = "TrayURL"
$TitleBar2 = "TrayURL Version 2.0, (c) 2007 Michael W. Bayley"
$TitleMain = " - Main"
$TitleSettings = " - URL Settings"
$TitleOptions = " - Options"
$TitlePaster = " - Paster Options"
$TitleBrowse = " - Browse for Browser Program"
$TitleAddCat = " - Add Category"
$TitleEditCat = " - Edit Category"
$TitleAddUrl = " - Add URL"
$TitleEditUrl = " - Edit URL"
$TitleCopyUrl = " - Copy URL"
$TitleMoveUrl = " - Move URL"
$TitleAuthor = "By Michael W. Bayley"

; INI Option Values
$WarnDefaultCatDelete = 0
$WarnDefaultUrlDelete = 1
$WarnDefaultOverwriteCopy = 1
$WarnDefaultOverwriteMove = 1
$WarnDefaultOverwriteAdd = 1
$WarnDefaultOverwriteEdit = 1
$CatDefaultMin = 10
$CatDefaultMax = 50
$UrlDefaultMin = 20
$UrlDefaultMax = 80
; <<<WORK HERE>>>
$CatCharsMax = 80
$UrlCharsMax = 80
 
; Program ID
$Tag = ""
$Major = 0
$Minor = 0

; Browser Values
$BrowserType = $IniBrowserTypeDefault
$UserBrowserTitle = ""
$UserBrowserProgram = ""
$UserBrowserDirectory = ""
$UserBrowserWindowClass = ""
$UserBrowserInputID = ""
$UserBrowserExecutable = ""

; System Default Browser Values
; WORK HERE - DDE Support?
$SystemProgram = ""
$SystemDirectory = ""
$SystemTitle = ""
$SystemWindowClass = ""
$SystemInputID = "" 
$SystemSelectKeys = ""
$SystemCopyKeys = ""

; MSIE Browser Values
$DefaultIEExe = "iexplore.exe"
$DefaultIEHtmlTag = "htmlfile"
$DefaultIEProgram = "Internet Explorer\IEXPLORE.EXE"
$DefaultIETitle = "<<<URL>>> - Microsoft Internet Explorer"
$DefaultIEWindowClass = "IEFrame"
$DefaultIEInputID = "Edit1"
$DefaultIESelectKeys = "{HOME}+{END}"
$DefaultIECopyKeys = $DefaultIESelectKeys & "^c"
$IEEnable = 1
$IEProgram = ""
$IEDirectory = ""
$IETitle = ""
$IEWindowClass = ""
$IEInputID = ""
$IESelectKeys = ""
$IECopyKeys = ""

; Firefix Browser Values
$DefaultFirefoxExe = "firefox.exe"
$DefaultFirefoxHtmlTag = "FirefoxHTML"
$DefaultFirefoxProgram = "Mozilla Firefox\Firefox.exe"
$DefaultFirefoxTitle = "<<<URL>>> - Mozilla Firefox"
$DefaultFirefoxWindowCLass = "MozillaUIWindowClass"
$DefaultFirefoxInputID = "MozillaWindowClass1"
$DefaultFirefoxSelectKeys = "^l"
$DefaultFirefoxCopyKeys = $DefaultFirefoxSelectKeys & "^c"
$FirefoxEnable = 1
$FirefoxProgram = ""
$FirefoxDirectory = ""
$FirefoxTitle = ""
$FirefoxWindowClass = ""
$FirefoxInputID = ""
$FirefoxSelectKeys = ""
$FirefoxCopyKeys = ""

; General Browser Values
$DefaultSelectKeys = "{HOME}+{END}"
$DefaultCopyKeys = $DefaultSelectKeys & "^c"
$DefaultNoInputIdSelectKeys = "{F6}"
$DefaultNoInputIDCopyKeys = $DefaultSelectKeys & "^c"

; Option Values
$WarnCatDelete = $WarnDefaultCatDelete
$WarnUrlDelete = $WarnDefaultUrlDelete
$WarnOverwriteCopy = $WarnDefaultOverwriteCopy
$WarnOverwriteMove = $WarnDefaultOverwriteMove
$WarnOverwriteAdd = $WarnDefaultOverwriteAdd
$WarnOverwriteEdit = $WarnDefaultOverwriteEdit
$WarnNoBrowser = 1
$WarnNoTitle = 1
$WarnNoInputID = 1

$CATMAX = $CatDefaultMin
$ITEMMAX = $UrlDefaultMin

; Key Coding Values
$KeyEnable = 0
$KeyTimeout = 0
$KeyTimer = 0
$KeyCode = ""

; Tray Menu Values
$Categories = 0
$MenuItems = 0
$CmdIndex = 0

; Cmd Menu Values
$CmdMenu = -1
$CmdMenuAddUrl = 1
$CmdMenuUrlSettings = 2
$CmdMenuOptions = 3
$CmdMenuQuit = 4

; Dialog Labels
$TextCategory = "Category"
$TextSCategory = "Source Category"
$TextTCategory = "Target Category"
$TextEntries = "Entries"
$TextAddCat = "Add Category"
$TextEditCat = "Edit Category"
$TextDelCat = "Delete Category"
$TextAddEntry = "Add Entry"
$TextEditEntry = "Edit Entry"
$TextDelEntry = "Delete Entry"
$TextCopyEntry = "Copy Entry"
$TextMoveEntry = "Move Entry"
$TextDone = "Done"

$TextBrowser = "Browser"
$TextBrowserDefault = "System Default"
$TextBrowserMSIE = "Internet Explorer"
$TextBrowserFirefox = "Mozilla Firefox"
$TextBrowserOther = "Other"
$TextBrowserTitle = "Browser Title Text"
$TextBrowserProgram = "Browser Executable"
$TextBrowse = "..."
$TextBrowserWindowClass = "Browser Window Class"
$TextBrowserInputID = "Browser Input ID"
$TextWarnings = "Warnings"
$TextWarnCatDel = "Delete Category"
$TextWarnCopy = "Overwrite on Copy"
$TextWarnMove = "Overwrite on Move"
$TextWarnAdd = "Overwrite on Add"
$TextWarnEdit = "Overwrite on Edit"
$TextWarnDel = "Delete URL"
$TextKeyEncode = "Key Encoding"
$TextKeyEnable = "Enable"
$TextKeyTimeout = "Timout after"
$TextKeyTimeout2 = "minutes"
$TextLimits = "Menu Size Limits"
$TextLimitsCat = "Categories:"
$TextLimitsURLs = "URL Entries:"

$TextEnable = "Paster Option Enable"
$TextHotKeys = "Program HotKeys"
$TextPLogin = "Paste Login"
$TextPPaswd = "Paste Password"
$TextPExit = "Exit Program"
$TextCtrl = "Ctrl"
$TextAlt = "Alt"
$TextShift = "Shift"

$TextName = "Description"
$TextUrl = "URL"
$TextLogin = "Login"
$TextPaswd = "Password"
$TextTabs = "Tabs"
$TextCR = "CR"
$TextClose = "Close"
$TextDate = "Last Visit"

$TextOK = "OK"
$TextCancel = "Cancel"
$TextPaster = "Paster Options"

; Regular Expression Values
$SearchClass = "classname="
$SearchCmd = "regexp="
$SearchLeft1 = "^("
$SearchLeft2 = ")+"
$SearchMid = ".*"
$SearchRight1 = "("
$SearchRight2 = ")+$"

; Macro Tag
$MacroURL = "<<<URL>>>"
$MacroCommonFiles = "<<<CommonFiles>>>"
$MacroProgramFiles = "<<<ProgramFiles>>>"
$MacroSystemDir = "<<<SystemDir>>>"
$MacroWindowsDir = "<<<WindowsDir>>>"

; Login Key
$KeyProgram = "TrayURL.exe"
$KeySource = "Edit1" 
$KeyKey = "Edit2"
$KeyResult = "Edit3"
$KeyEncode = "Button1"
$KeyDecode = "Button2"

; Support Utilities
$PasterProgram = "TrayUrlPaster.exe"


;
; Main Code
;
; Entry:       <None>
; Return:      0 - No errors
;              1 - Fatal error encountered
; Procedure:   1. Exit if already running.
;              2. Verify TrayURL.exe is running.
;              2. If command line parameter then message & exit.
;              3. Error if ini file not found.
;              4. Read basic setting & allocate array space.
;              5, Build the menu
;              6. Process user commands.
;              7. Exit all done.

AutoItSetOption("SendKeyDelay", 1)
; 1. Exit if already running.
If @Compiled Then
   $List = ProcessList(@ScriptName)
   If $List[0][0] > 1 Then Exit(0)
EndIf


; 2. Verify TrayURL.exe is running.
If CheckMain() == 0 Then
   MsgBox(0, $TitleBar2, "This program must be run from " & Chr(34) & $KeyProgram & Chr(34) & "!")
   Exit(1)
EndIf


; 3. If command line parameter then message & exit.
If $CmdLine[0] > 1 Then
   $msg = "This program will put a series of URLs at your instantaneous" & @CRLF
   $msg = $msg & "disposal via an icon in the system tray.  No command line" & @CRLF
   $msg = $msg & "parameters are required, but a single optional parameter may" & @CRLF
   $msg = $msg & "be supplied to override the default profile (please see the" & @CRLF
   $msg = $msg & "documentation for full details)." & @CRLF & @CRLF
   $msg = $msg & "In all instances the profile file msut exist in the same directory" & @CRLF
   $msg = $msg & "as the program." & @CRLF & @CRLF
   MsgBox(0, $TitleBar2, $msg)
   Exit(1)
ElseIf $CmdLine[0] == 1 Then
   $IniFile = @ScriptDir
   If StringRight($IniFile, 1) == "\" Then
      $IniFile = $IniFile & $CmdLine[1] & ".ini"
   Else
      $IniFile = $IniFile & "\" & $CmdLine[1] & ".ini"
   EndIf
EndIf


; 4. Error if ini file not found.
If FileExists($IniFile) <> 1 Then
   $msg = "Welcome to TrayURL.  This program is a small and portable bookmark manager that" & @CRLF
   $msg = $msg & "will put all of your favorite web sites at the tip of your fingers.  You use this software" & @CRLF
   $msg = $msg & "at your own risk.  There are no guarantees or warranties, implied or explicit." & @CRLF & @CRLF
   $msg = $msg & "The configuration file " & $IniFile & @CRLF
   $msg = $msg & "does not exist.  Create it?" & @CRLF & @CRLF
   If MsgBox(260, $TitleBar2, $msg) <> 6 Then Exit(1)
   
   $msg = FileOpen($IniFile, 10)
   If $msg == -1 Then
      MsgBox(0, $TitleBar2, "Fatal Error - Can't create " & $IniFile & "!")
      Exit(1)
   EndIf
   FileClose($msg)
   IniWrite($IniFile, $IniProgram, $IniTag, $IniProgram)
   IniWrite($IniFile, $IniProgram, $IniMajor, $VerMajor)
   IniWrite($IniFile, $IniProgram, $IniMinor, $VerMinor)
   IniWrite($IniFile, $IniProgram, $IniBrowserType, $IniBrowserTypeDefault)
   IniWrite($IniFile, $IniCatSection, $IniItems, 1)
   IniWrite($IniFile, $IniCatSection, $IniItem & "1", "Software")
   IniWrite($IniFile, $IniCatMain, $IniItems, "2")
   IniWrite($IniFile, $IniCatMain, $IniName & "1", "Google")
   IniWrite($IniFile, $IniCatMain, $IniURL & "1", "http://www.google.com")
   IniWrite($IniFile, $IniCatMain, $IniName & "2", "Yahoo")
   IniWrite($IniFile, $IniCatMain, $IniURL & "2", "http://www.yahoo.com")
   IniWrite($IniFile, "Software", $IniItems, "1")
   IniWrite($IniFile, "Software", $IniName & "1", "AutoIt Homepage")
   IniWrite($IniFile, "Software", $IniURL & "1", "http://www.autoitscript.com")
EndIf


; 5. Read basic setting & allocate array space.
; Verify ini data
$Tag = IniRead($IniFile, $IniProgram, $IniTag, $IniTag)
$Major = Number(IniRead($IniFile, $IniProgram, $IniMajor, $Major))
$Minor = Number(IniRead($IniFile, $IniProgram, $IniMinor, $Minor))

If $Tag <> $IniProgram Then
   MsgBox(0, $TitleBar2, "Error - " & $IniFile & " is not a TrayURL profile file.")
   Exit(1)
EndIf

; Read browser settings
$BrowserType = IniRead($IniFile, $IniProgram, $IniBrowserType, $IniBrowserTypeDefault)
$UserBrowserTitle = IniRead($IniFile, $IniProgram, $IniBrowserTitle, "")
$UserBrowserProgram = IniRead($IniFile, $IniProgram, $IniBrowserProgram, "")
$UserBrowserExecutable = MacroDecode($UserBrowserProgram)
$UserBrowserDirectory = GetDirectory($UserBrowserExecutable)
$UserBrowserWindowClass = IniRead($IniFile, $IniProgram, $IniBrowserWindowClass, "")
$UserBrowserInputID = IniRead($IniFile, $IniProgram, $IniBrowserInputID, "")

LocateMSIE("")
LocateFirefox("")
LocateDefault()

$WarnCatDelete = Number(IniRead($IniFile, $IniProgram, $IniWarnCatDelete, $WarnDefaultCatDelete))
$WarnUrlDelete = Number(IniRead($IniFile, $IniProgram, $IniWarnUrlDelete, $WarnDefaultUrlDelete))
$WarnOverwriteCopy = Number(IniRead($IniFile, $IniProgram, $IniWarnOverwriteCopy, $WarnDefaultOverwriteCopy))
$WarnOverwriteMove = Number(IniRead($IniFile, $IniProgram, $IniWarnOverwriteMove, $WarnDefaultOverwriteMove))
$WarnOverwriteAdd = Number(IniRead($IniFile, $IniProgram, $IniWarnOverwriteAdd, $WarnDefaultOverwriteAdd))
$WarnOverwriteEdit = Number(IniRead($IniFile, $IniProgram, $IniWarnOverwriteEdit, $WarnDefaultOverwriteEdit))

; If default browser make sure it is defined
If $BrowserType == $IniBrowserTypeDefault AND StringLen($SystemProgram) == 0 Then
   MsgBox(0, $TitleBar2, "Warning - The system default browser was not found.  Setting browser to user defined!")
   $BrowserType = $IniBrowserTypeOther
EndIf

; If custom browser make sure it is defined
If $BrowserType == $IniBrowserTypeOther Then
   $text = "!"
   While StringLen($text)
      $text = ""
      If StringLen($UserBrowserProgram) == 0 Then
         $text = "WARNING!!! - You have TrayURL configured to run with a browser other than" & @CRLF
         $text = $text & "Microsoft Internet Explorer or Mozilla Firefox.  In order for TrayURL to operate" & @CRLF
         $text = $text & "correctly you must provide information regarding your browser to" & @CRLF & @CRLF
         $text = $text & "You currently do not have a definition for the browser program location.  Please" & @CRLF
         $text = $text & "enter the information in the Options Dialog." & @CRLF & @CRLF
      ElseIf StringLen($UserBrowserTitle) == 0 Then
         $text = "WARNING!!! - You have TrayURL configured to run with a browser other than" & @CRLF
         $text = $text & "Microsoft Internet Explorer or Mozilla Firefox.  In order for TrayURL to operate" & @CRLF
         $text = $text & "correctly you must provide information regarding your browser to" & @CRLF & @CRLF
         $text = $text & "You currently do not have a definition for the browser title bar text.  Please" & @CRLF
         $text = $text & "enter the information in the Options Dialog." & @CRLF & @CRLF
      ElseIf StringLen($UserBrowserWindowClass) == 0 Then
         $text = "WARNING!!! - You have TrayURL configured to run with a browser other than" & @CRLF
         $text = $text & "Microsoft Internet Explorer or Mozilla Firefox.  In order for TrayURL to operate" & @CRLF
         $text = $text & "correctly you must provide information regarding your browser to" & @CRLF & @CRLF
         $text = $text & "You currently do not have a definition for the browser windows class.  Please" & @CRLF
         $text = $text & "enter the information in the Options Dialog." & @CRLF & @CRLF
      ElseIf StringLen($UserBrowserInputID) == 0 Then
         $text = "WARNING!!! - You have TrayURL configured to run with a browser other than" & @CRLF
         $text = $text & "Microsoft Internet Explorer or Mozilla Firefox.  In order for TrayURL to operate" & @CRLF
         $text = $text & "correctly you must provide information regarding your browser to" & @CRLF & @CRLF
         $text = $text & "You currently do not have a definition for the browser inputbox ID.  Please" & @CRLF
         $text = $text & "enter the information in the Options Dialog." & @CRLF & @CRLF
      EndIf

      If StringLen($Text) Then
         MsgBox(0, $TitleBar2, $text)
         If Options() <> 1 Then
            Exit(1)
         EndIf
         If $BrowserType <> $IniBrowserTypeOther Then
            $text = ""
         EndIf
      EndIf
   WEnd
EndIf

; Read menu size limits
$CATMAX = Number(IniRead($IniFile, $IniProgram, $IniCatMax, $CATMAX))
$ITEMMAX = Number(IniRead($IniFile, $IniProgram, $IniUrlMax, $ITEMMAX))

; Allocate storage space
Dim   $MenuEntries[($CATMAX * $ITEMMAX) + 1][5]
Dim   $MenuCats[($CATMAX * $ITEMMAX) + 1][5]
Dim   $MenuItms[($CATMAX * $ITEMMAX) + 1][5]
$MenuLine = 0

$KeyEnable = Number(IniRead($IniFile, $IniProgram, $IniKeyEnable, 0))
$KeyTimeout = Number(IniRead($IniFile, $IniProgram, $IniKeyTimeout, 0))
If $KeyTimeout <> 0 Then
   If $KeyTimeout < 5 Then $KeyTimeout = 5
   If $KeyTimeout > 120 Then $KeyTimeout = 120
EndIf


; 6. Build the Menu.
BuildTrayMenu()


; 7. Process user commands.
$notDone = 1
While $notDone
   $cmd = TrayGetMsg()
   $CmdIndex = 0

   If $KeyTimer Then
      If (TimerDiff($KeyTimer) / 60000) > $KeyTimeout Then
         $KeyTimer = 0
         $KeyCode = ""
      EndIf
   EndIf

   If StringLen($cmd) == 0 or $cmd == 0 Then ContinueLoop
   For $loop = 1 To $MenuItems
      If $cmd == $MenuEntries[$loop][0] Then
         $CmdIndex = $loop
         ExitLoop
      EndIf
   Next
   
   If $CmdIndex <> 0 Then
      $cat = $MenuCats[$CmdIndex][0]
      $itm = $MenuItms[$CmdIndex][0]
      
      If $cat == $CmdMenu Then
         If $itm == $CmdMenuAddUrl Then
            ; Add URL
            DestroyTrayMenu()
            AddURL()
            BuildTrayMenu()
            If StringLen($KeyCode) AND $KeyTimeout Then
               $KeyTimer = TimerInit()
            EndIf
         ElseIf $itm == $CmdMenuUrlSettings Then
            ; URL Settings
            DestroyTrayMenu()
            Settings()
            BuildTrayMenu()
            If StringLen($KeyCode) AND $KeyTimeout Then
               $KeyTimer = TimerInit()
            EndIf
         ElseIf $itm == $CmdMenuOptions Then
            ; URL Settings
            DestroyTrayMenu()
            Options()
            BuildTrayMenu()
            If StringLen($KeyCode) AND $KeyTimeout Then
               $KeyTimer = TimerInit()
            EndIf
         ElseIf $itm == $CmdMenuQuit Then
            ; Quit
            $notDone = 0
         Else
            MsgBox(0, $TitleBar3, "Error - Unknown command index " & $itm & "!")
         EndIf
      ElseIf $cat = 0 Then
         $cat = $IniCatMain
      Else
         $cat = IniRead($IniFile, $IniCatSection, $IniItem & $cat, "")
      EndIf
      
      If $cat <> $CmdMenu Then
         $record = ReadRecordByIndex($TitleBar2, $cat, $itm)
         If StringLen($record[$RECURL]) Then
            LaunchURL($record[$RECURL])
            If StringLen($record[$RECLOGIN]) OR StringLen($record[$RECPASWD]) Then
               LaunchPaster($record[$RECLOGIN], $record[$RECPASWD], $record[$RECFLAGS])
            EndIf
            WriteFieldByIndex($TitleBar2, $cat, $RECDATE, $itm, GetDateStr())
            If StringLen($KeyCode) AND $KeyTimeout Then
               $KeyTimer = TimerInit()
            EndIf
         EndIf
      EndIf
   EndIf
WEnd


; 8. Exit all done.
Exit(0)


;
; User Defined Functions
; Tray Menu Support
;

;
; DestroyTrayMenu()
; Entry:       <None>
; Return:      0
; Procedure:   1. Destroy the menu.
;              2. Return done.
;

Func  DestroyTrayMenu()
   Local    $loop
   
   ; 1. Destroy the menu.
   For $loop = 1 To $MenuItems
      TrayItemDelete($MenuEntries[$loop][0])
      $MenuEntries[$loop][0] = 0
   Next
   
   TrayItemDelete($MenuLine)
   $MenuLine = 0
   
   
   ; 2. Return done.
   Return(0)
EndFunc


;
; BuildTrayMenu()
; Entry:       <None>
; Return:      <None>
; Procedure:   1. Build the Main Menu Body.
;              2. Add in non category items.
;              3. Add in main menu commands
;              4. Return done.
;

Func  BuildTrayMenu()
   Local    $notDone
   Local    $loop
   Local    $loop2
   Local    $cat
   Local    $catItem
   Local    $items
   Local    $item
   
   ; 1. Build the Main Menu Body.
   $MenuItems = 1
   $Categories = IniRead($IniFile, $IniCatSection, $IniItems, 0)
   If $Categories > $CATMAX Then
      MsgBox(0, $TitleBar2, "Warning - Too many categories!" & @CRLF & "Extra categories ignored!")
      $Categories = $CATMAX
   EndIf

   For $loop = 1 To $Categories
      $cat = IniRead($IniFile, $IniCatSection, $IniItem & $loop, "")
      $catItem = $MenuItems
      $MenuEntries[$MenuItems][0] = TrayCreateMenu($cat)
      $MenuItems = $MenuItems + 1
   
      $items = Number(IniRead($IniFile, $cat, $IniItems, 0))
      If $items > $ITEMMAX Then
         MsgBox(0, $TitleBar2, "Warning - Too many items in category " & $cat & "!" & @CRLF & "Extra items ignored!")
         $items = $ITEMMAX
      EndIf

      For $loop2 = 1 To $items
         $item = ReadFieldByIndex($TitleBar2, $cat, $RECNAME, $loop2)
         If StringLen($item) Then
            $MenuEntries[$MenuItems][0] = TrayCreateItem($item, $MenuEntries[$catItem][0])
            $MenuCats[$MenuItems][0] = $loop
            $MenuItms[$MenuItems][0] = $loop2
            $MenuItems = $MenuItems + 1
         Else
            MsgBox(0, $TitleBar2, "Warning - NULL item in category " & $cat & "!" & @CRLF & "Items ignored!")
         EndIf
      Next
   Next 


   ; 2. Add in non category items.
   $items = Number(IniRead($IniFile, $IniCatMain, $IniItems, 0))
   If $items > $ITEMMAX Then
      MsgBox(0, $TitleBar2, "Warning - Too many items in category Main!" & @CRLF & "Extra items ignored!")
      $items = $ITEMMAX
   EndIf

   For $loop2 = 1 To $items
      $item = ReadFieldByIndex($TitleBar2, $IniCatMain, $RECNAME, $loop2)
      If StringLen($item) Then
         $MenuEntries[$MenuItems][0] = TrayCreateItem($item)
         $MenuCats[$MenuItems][0] = 0
         $MenuItms[$MenuItems][0] = $loop2
         $MenuItems = $MenuItems + 1
      Else
         MsgBox(0, $TitleBar2, "Warning - NULL item in category Main!" & @CRLF & "Items ignored!")
      EndIf
   Next


   ; 3. Add in main menu commands
   $MenuLine = TrayCreateItem("")
   $MenuEntries[$MenuItems][0] = TrayCreateItem("Add URL")
   $MenuCats[$MenuItems][0] = $CmdMenu
   $MenuItms[$MenuItems][0] = $CmdMenuAddUrl
   $MenuItems = $MenuItems + 1
   $MenuEntries[$MenuItems][0] = TrayCreateItem("URL Settings")
   $MenuCats[$MenuItems][0] = $CmdMenu
   $MenuItms[$MenuItems][0] = $CmdMenuUrlSettings
   $MenuItems = $MenuItems + 1
   $MenuEntries[$MenuItems][0] = TrayCreateItem("Options")
   $MenuCats[$MenuItems][0] = $CmdMenu
   $MenuItms[$MenuItems][0] = $CmdMenuOptions
   $MenuItems = $MenuItems + 1
   $MenuEntries[$MenuItems][0] = TrayCreateItem("Quit")
   $MenuCats[$MenuItems][0] = $CmdMenu
   $MenuItms[$MenuItems][0] = $CmdMenuQuit
   $MenuItems = $MenuItems + 1


   ; 4. Return done.
   TraySetState()
   Return(0)
EndFunc


;
; User Defined Functions
; Settings and Settings Support
;

;
; Setting()
; Entry:       <None>
; Return:      <None>
; Procedure:   1. Build the dialog. 
;              2. Populate category list.
;              3. Populate URL list.
;              4. Get user input.
;

Func  Settings()
   Local    $dlg
   Local    $combo, $edit1
   Local    $button1, $button2, $button3
   Local    $button4, $button5, $button6
   Local    $button7, $button8, $button9
   Local    $buttonA, $buttonB
   Local    $cat, $cat2
   Local    $record = CreateRecord("", "", "", "", 0, "")
   Local    $notDone, $notDone2, $msg
   Local    $list, $text, $index, $items
   
   ; 1. Create the dialog.
   $dlg = GUICreate($TitleBar & $TitleSettings, 300, 390)
   GUICtrlCreateLabel($TextCategory, 20, 10, 260, 20)
   $combo = GUICtrlCreateCombo($IniCatMain, 20, 30, 260, 140)
   GUICtrlCreateLabel($TextEntries, 20, 60, 260, 20)
   $edit1 = GUICtrlCreateList("", 20, 80, 260, 160, $WS_VSCROLL)
   $button1 = GUICtrlCreateButton($TextAddCat, 16, 260, 84, 30)
   $button2 = GUICtrlCreateButton($TextEditCat, 108, 260, 84, 30)
   $button3 = GUICtrlCreateButton($TextDelCat, 200, 260, 84, 30)
   $button4 = GUICtrlCreateButton($TextAddEntry, 16, 300, 84, 30)
   $button5 = GUICtrlCreateButton($TextEditEntry, 108, 300, 84, 30)
   $button6 = GUICtrlCreateButton($TextDelEntry, 200, 300, 84, 30)
   $button7 = GUICtrlCreateButton($TextCopyEntry, 16, 340, 84, 30)
   $button8 = GUICtrlCreateButton($TextDone, 108, 340, 84, 30)
   $button9 = GUICtrlCreateButton($TextMoveEntry, 200, 340, 84, 30)
   GUICtrlSetState($button8, $GUI_DEFBUTTON)


   ; 2. Populate category list.
   $list = BuildCategoryList($combo, $IniCatMain)


   ; 3. Populate URL list.
   $cat = $IniCatMain
   $items = BuildEntryList($edit1, $cat)
   GUISetState(@SW_SHOW, $dlg)


   ; 4. Get user inputs.
   $notDone = 1
   While $notDone
      $msg = GUIGetMsg()

      Select
         Case $msg == $GUI_EVENT_CLOSE
            ; Close dialog
            $notDone = 0
         Case $msg == $combo
            ; Change category
            $text = GUICtrlRead($combo)
            If $text <> $cat Then
               $cat = $text
               $items = BuildEntryList($edit1, $cat)
            EndIf
         Case $msg == $button1
            ; Add category
            GUISetState(@SW_DISABLE, $dlg)
            $items = Number(IniRead($IniFile, $IniCatSection, $Items, 0))
            If $items >= $CATMAX Then
               MsgBox(0, $TitleBar2, "Error - Maximum number of categories reached!")
            Else            
               $text = ""
               $notDone2 = 1
               While $notDone2
                  $text = InputBox($TitleBar & $TitleAddCat, "Enter new category name", $text, "", 300, 100)
                  If StringLen($text) Then
                     If StringInStr($text, $RECSEP) Then
                        ; Can't use seperator character
                        MsgBox(0, $TitleBar2, "Error - Can't use '" & $RECSEP & "' as part of a category name!")
                     ElseIf StringInStr($text, "[") OR StringInStr($text, "]") Then
                        ; Can't use section indicators
                        MsgBox(0, $TitleBar2, "Error - Can't use '[' or ']' as part of a category name!")
                     ElseIf StringInStr($list, $text) Then
                        ; Error if category already exists
                        MsgBox(0, $TitleBar2, "Error - Category '" & $text & " already exists!")
                     Else
                        ; Add to category list
                        $cat = $text
                        AddCatToIni($TitleBar2, $cat, 1)
                        $list = BuildCategoryList($combo, $cat)
                        $items = BuildEntryList($edit1, $cat)
                        $notDone2 = 0
                     EndIf
                  Else
                     $notDone2 = 0
                  EndIf
               WEnd
            EndIf
            GUISetState(@SW_ENABLE, $dlg)
            GUISetState(@SW_HIDE, $dlg)
            GUISetState(@SW_SHOW, $dlg)
         Case $msg == $button2
            ; Edit category
            GUISetState(@SW_DISABLE, $dlg)
            If $cat == $IniCatMain Then
               MsgBox(0, $TitleBar2, "Info - You cannot edit the main category!")
            Else
               $text = $cat
               $notDone2 = 1
               While $notDone2
                  $text = InputBox($TitleBar & $TitleEditCat, "Enter new category name", $text, "", 300, 100)
                  If StringLen($text) Then
                     If StringInStr($text, $RECSEP) Then
                        ; Can't use seperatore character
                        MsgBox(0, $TitleBar2, "Error - Can't use '" & $RECSEP & "' as part of a category name!")
                     ElseIf StringInStr($text, "[") OR StringInStr($text, "]") Then
                        ; Can't use section indicators
                        MsgBox(0, $TitleBar2, "Error - Can't use '[' or ']' as part of a category name!")
                     ElseIf StringInStr($list, $text) Then
                        ; Error if category already exists
                        MsgBox(0, $TitleBar2, "Error - Category '" & $text & " already exists!")
                     Else
                        ; Rename category
                        RenCatToIni($TitleBar2, $cat, $text)
                        $cat = $text
                        $list = BuildCategoryList($combo, $cat)
                        $items = BuildEntryList($edit1, $cat)
                        $notDone2 = 0
                     EndIf
                  Else
                     $notDone2 = 0
                  EndIf
               WEnd
            EndIf
            GUISetState(@SW_ENABLE, $dlg)
            GUISetState(@SW_HIDE, $dlg)
            GUISetState(@SW_SHOW, $dlg)
         Case $msg == $button3
            ; Delete category
            If $cat == $IniCatMain Then
               MsgBox(0, $TitleBar2, "Info - You cannot delete the main category!")
            Else
               If DelCatFromIni($TitleBar2, $cat, $WarnCatDelete) Then
                  $cat = $IniCatMain
                  $list = BuildCategoryList($combo, $cat)
                  $items = BuildEntryList($edit1, $cat)
               EndIf
            EndIf
            GUISetState(@SW_HIDE, $dlg)
            GUISetState(@SW_SHOW, $dlg)
         Case $msg == $button4
            ; Add URL
            GUISetState(@SW_DISABLE, $dlg)
            $cat2 = AddUrlDialog($cat, "", "", "", "", 0, "", 1)
            If StringLen($cat2) Then
               If $cat2 <> $cat Then
                  $cat = $cat2
                  GUICtrlSetData($combo, $cat)
               EndIf
               $items = BuildEntryList($edit1, $cat)
            EndIf
            GUISetState(@SW_ENABLE, $dlg)
            GUISetState(@SW_HIDE, $dlg)
            GUISetState(@SW_SHOW, $dlg)
         Case $msg == $button5
            ; Edit URL entry
            $text = GUICtrlRead($edit1)
            If StringLen($text) == 0 Then
               MsgBox(0, $TitleBar2, "Error - No entry selected!")
            Else
               GUISetState(@SW_DISABLE, $dlg)
               $record = ReadRecordByName($TitleBar2, $cat, $text)
               $cat2 = AddUrlDialog($cat, $record[$RECNAME], $record[$RECURL], $record[$RECLOGIN], $record[$RECPASWD], $record[$RECFLAGS], $record[$RECDATE], 0)
               If StringLen($cat2) Then
                  $items = BuildEntryList($edit1, $cat)
               EndIf
               GUISetState(@SW_ENABLE, $dlg)
               GUISetState(@SW_HIDE, $dlg)
               GUISetState(@SW_SHOW, $dlg)
            EndIf
         Case $msg == $button6
            ; Delete URL entry
            $text = GUICtrlRead($edit1)
            If StringLen($text) == 0 Then
               MsgBox(0, $TitleBar2, "Error - No entry selected!")
            Else
               If DelEntryFromIni($TitleBar2, $cat, $text, $WarnUrlDelete) == 1 Then
                  $items = BuildEntryList($edit1, $cat)
               EndIf
            EndIf
            GUISetState(@SW_HIDE, $dlg)
            GUISetState(@SW_SHOW, $dlg)
         Case $msg == $button7
            ; Copy URL entry
            GUISetState(@SW_DISABLE, $dlg)
            $text = GUICtrlRead($edit1)
            $record = ReadRecordByName($TitleBar2, $cat, $text)
            $cat2 = CopyUrlDialog($cat, $record[$RECNAME], $record[$RECURL], $record[$RECLOGIN], $record[$RECPASWD], $record[$RECFLAGS], $record[$RECDATE], 1)
            GUISetState(@SW_ENABLE, $dlg)
            GUISetState(@SW_HIDE, $dlg)
            GUISetState(@SW_SHOW, $dlg)
         Case $msg == $button8
            ; Done
            $notDone = 0
         Case $msg == $button9
            ; Move URL entry
            GUISetState(@SW_DISABLE, $dlg)
            $text = GUICtrlRead($edit1)
            $record = ReadRecordByName($TitleBar2, $cat, $text)
            $cat2 = CopyUrlDialog($cat, $record[$RECNAME], $record[$RECURL], $record[$RECLOGIN], $record[$RECPASWD], $record[$RECFLAGS], $record[$RECDATE], 0)
            If StringLen($cat2) Then
               DelEntryFromIni($TitleBar2, $cat, $record[$RECNAME], 0)
               $items = BuildEntryList($edit1, $cat)
            EndIf
            GUISetState(@SW_ENABLE, $dlg)
            GUISetState(@SW_HIDE, $dlg)
            GUISetState(@SW_SHOW, $dlg)
      EndSelect
   WEnd


   GUIDelete($dlg)
   Return(0)
EndFunc


;
; BuildCategoryList($control, $cat)
; Entry:       $control    List control ID
;              $cat        Category to select
; Return:      $list       Returns a list of categories
; Procedure:   1. Populate category list.
;              2. Exit all done.
;

Func  BuildCategoryList($control, $cat)
   Local    $list, $items, $index, $text
   
   ; 1. Populate category list.
   $list = $RECSEP & $IniCatMain
   $items = Number(IniRead($IniFile, $IniCatSection, $IniItems, 0))
   $index = 1
   While $index <= $items
      $text = IniRead($IniFile, $IniCatSection, $IniItem & $index, "")
      If StringLen($text) Then
         $list &= $RECSEP & $text
      EndIf
      $index += 1
   WEnd
   GUICtrlSetData($control, $list, $cat)
   GUICtrlSetState($control, 0)


   ; 2. Exit all done.
   Return($list)
EndFunc


;
; BuildEntryList($control, $cat)
; Entry:       $control    List control ID
;              $cat        Category to use
; Return:      $items      Number of items in the list
; Procedure:   1. Populate URL list.
;              2. Exit all done.
;

Func  BuildEntryList($control, $cat)
   Local    $list, $item, $items, $index, $text
   
   ; 1. Populate URL list.
   $list = ""
   $items = Number(IniRead($IniFile, $cat, $IniItems, 0))
   $index = 1
   $item = ""
   While $index <= $items
      $text = ReadFieldByIndex($TitleBar2, $cat, $RECNAME, $index)
      If StringLen($text) Then
         $list &= $RECSEP & $text
         If StringLen($item) == 0 Then
            $item = $text
         EndIf
      EndIf
      $index += 1
   WEnd
   GUICtrlSetData($control, $list, $item)
   GUICtrlSetState($control, 0)


   ; 2. Exit all done.
   Return($items)
EndFunc


;
; User Defined Functions
; Options and Options Support
;

;
; Options()
; Entry:       <None>
; Return:      0 if user aborts
;              1 if normal exit
; Procedure:   1. Build the dialog. 
;              2. Populate data. 
;              3. Get user input.
;              4. Exit if cancel.
;              5. Validate data.
;              6. Warn if max values changed.
;              7. Update INI file.
;              8. Exit all done.
;
; WORK HERE - DDE SUpport?

Func  Options()
   Local    $dlg
   Local    $group1, $group2, $group3
   Local    $radio1, $radio2, $radio3, $radio4
   Local    $edit1, $edit2, $edit5, $edit6
   Local    $check1, $check2, $check3
   Local    $check4, $check5, $check6
   Local    $check7, $check8, $edit8
   Local    $edit3, $edit4
   Local    $button1, $button2, $button3, $button4
   Local    $orgBrowserType, $orgBrowserTitle, $orgBrowserProgram
   Local    $orgBrowserWindowClass, $orgBrowserInputID
   Local    $orgCatMax, $orgUrlMax, $newCatMax, $newUrlMax
   Local    $orgCatDelete, $orgOverwriteCopy, $orgOverwriteMove
   Local    $orgUrlDelete, $orgOverwriteAdd, $orgOverwriteEdit
   Local    $orgKeyEnable, $orgKeyTimeout, $newKeyEnable, $newKeyTimeout
   Local    $newItem, $text, $reply, $tag
   Local    $notDone, $notDone2, $msg
   Local    $retcode

   ; 1. Create the dialog.
   $retcode = 1
   $dlg = GUICreate($TitleBar & $TitleOptions, 300, 490)
   $group1 = GUICtrlCreateGroup($TextBrowser, 20, 10, 260, 65)
   $radio1 = GUICtrlCreateRadio($TextBrowserDefault, 30, 25, 100, 20)
   $radio2 = GUICtrlCreateRadio($TextBrowserMSIE, 164, 25, 100, 20)
   $radio3 = GUICtrlCreateRadio($TextBrowserFirefox, 30, 46, 100, 20)
   $radio4 = GUICtrlCreateRadio($TextBrowserOther, 164, 46, 100, 20)
   GUICtrlCreateLabel($TextBrowserTitle, 20, 86, 260, 20)
   $edit1 = GUICtrlCreateInput("", 20, 101, 260, 20)
   GUICtrlCreateLabel($TextBrowserProgram, 20, 129, 260, 20)
   $edit2 = GUICtrlCreateInput("", 20, 144, 230, 20)
   $button3 = GUICtrlCreateButton($TextBrowse, 260, 144, 20, 20)
   GUICtrlCreateLabel($TextBrowserWindowClass, 20, 172, 120, 20)
   $edit5 = GUICtrlCreateInput("", 20, 187, 120, 20)
   GUICtrlCreateLabel($TextBrowserInputID, 158, 172, 120, 20)
   $edit6 = GUICtrlCreateInput("", 158, 187, 120, 20)
   $group2 = GUICtrlCreateGroup($TextWarnings, 20, 216, 260, 95)
   $check1 = GUICtrlCreateCheckbox($TextWarnCatDel, 30, 230, 110, 30)
   $check2 = GUICtrlCreateCheckbox($TextWarnCopy, 30, 252, 110, 30)
   $check3 = GUICtrlCreateCheckbox($TextWarnMove, 30, 274, 110, 30)
   $check4 = GUICtrlCreateCheckbox($TextWarnDel, 164, 230, 110, 30)
   $check5 = GUICtrlCreateCheckbox($TextWarnAdd, 164, 252, 110, 30)
   $check6 = GUICtrlCreateCheckbox($TextWarnEdit, 164, 274, 110, 30)
   $group3 = GUICtrlCreateGroup($TextKeyEncode, 20, 320, 260, 51)
   $check7 = GUICtrlCreateCheckbox($TextKeyEnable, 30, 339, 50, 20)
   $check8 = GUICtrlCreateCheckbox($TextKeyTimeout, 103, 339, 75, 20)
   $edit8 = GUICtrlCreateInput("0", 180, 339, 45, 20)
   GUICtrlCreateUpDown($edit8)
   GUICtrlCreateLabel($TextKeyTimeout2, 230, 342, 40, 20)
   $group4 = GUICtrlCreateGroup($TextLimits, 20, 380, 260, 51)
   GUICtrlCreateLabel($TextLimitsCat, 30, 402, 80, 20)
   $edit3 = GUICtrlCreateInput("0", 96, 400, 40, 20)
   GUICtrlCreateUpDown($edit3)
   GUICtrlCreateLabel($TextLimitsURLs, 164, 402, 80, 20)
   $edit4 = GUICtrlCreateInput("0", 230, 400, 40, 20)
   GUICtrlCreateUpDown($edit4)
   $button1 = GUICtrlCreateButton($TextOK, 17, 445, 80, 30)
   $button2 = GUICtrlCreateButton($TextCancel, 108, 445, 80, 30)
   $button4 = GUICtrlCreateButton($TextPaster, 199, 445, 80, 30)
   GUICtrlSetState($button1, $GUI_DEFBUTTON)


   ; 2. Populate data.
   $orgBrowserType = $BrowserType
   Select
      Case $BrowserType == $IniBrowserTypeDefault
            GUICtrlSetState($radio1, $GUI_CHECKED)
      Case $BrowserType == $IniBrowserTypeMSIE
            GUICtrlSetState($radio2, $GUI_CHECKED)
      Case $BrowserType == $IniBrowserTypeFirefox
            GUICtrlSetState($radio3, $GUI_CHECKED)
      Case $BrowserType == $IniBrowserTypeOther
            GUICtrlSetState($radio4, $GUI_CHECKED)
   EndSelect
   If $IEEnable == 0 Then GUICtrlSetState($radio2, $GUI_DISABLE)
   If $FirefoxEnable == 0 Then GUICtrlSetState($radio3, $GUI_DISABLE)
   $orgBrowserTitle = $UserBrowserTitle
   GUICtrlSetData($edit1, $UserBrowserTitle)
   $orgBrowserProgram = $UserBrowserProgram
   GUICtrlSetData($edit2, $UserBrowserProgram)
   $orgBrowserWindowClass = $UserBrowserWindowClass
   GUICtrlSetData($edit5, $UserBrowserWindowClass)
   $orgBrowserInputID = $UserBrowserInputID
   GUICtrlSetData($edit6, $UserBrowserInputID)

   $orgCatDelete = $WarnCatDelete   
   If $WarnCatDelete Then
      GUICtrlSetState($check1, $GUI_CHECKED)
   Else
      GUICtrlSetState($check1, $GUI_UNCHECKED)
   EndIf
   $orgOverwriteCopy = $WarnOverwriteCopy
   If $WarnOverwriteCopy Then
      GUICtrlSetState($check2, $GUI_CHECKED)
   Else
      GUICtrlSetState($check2, $GUI_UNCHECKED)
   EndIf
   $orgOverwriteMove = $WarnOverwriteMove
   If $WarnOverwriteMove Then
      GUICtrlSetState($check3, $GUI_CHECKED)
   Else
      GUICtrlSetState($check3, $GUI_UNCHECKED)
   EndIf
   $orgUrlDelete = $WarnUrlDelete
   If $WarnUrlDelete Then
      GUICtrlSetState($check4, $GUI_CHECKED)
   Else
      GUICtrlSetState($check4, $GUI_UNCHECKED)
   EndIf
   $orgOverwriteAdd = $WarnOverwriteAdd
   If $WarnOverwriteAdd Then
      GUICtrlSetState($check5, $GUI_CHECKED)
   Else
      GUICtrlSetState($check5, $GUI_UNCHECKED)
   EndIf
   $orgOverwriteEdit = $WarnOverwriteEdit
   If $WarnOverwriteEdit Then
      GUICtrlSetState($check6, $GUI_CHECKED)
   Else
      GUICtrlSetState($check6, $GUI_UNCHECKED)
   EndIf
   GUICtrlSetLimit($edit3, 3, 1)
   GUICtrlSetLimit($edit4, 3, 1)

   $orgKeyEnable = $KeyEnable
   $orgKeyTimeout = $KeyTimeout
   If $KeyEnable Then
      GUICtrlSetState($check7, $GUI_CHECKED)
      If $KeyTimeout Then
         GUICtrlSetState($check8, $GUI_CHECKED)
         GUICtrlSetData($edit8, $KeyTimeout)
      Else
         GUICtrlSetState($check8, $GUI_UNCHECKED)
         GUICtrlSetState($edit8, $GUI_DISABLE)
      EndIf
   Else
      GUICtrlSetState($check7, $GUI_UNCHECKED)
      GUICtrlSetState($check8, $GUI_UNCHECKED)
      GUICtrlSetState($check8, $GUI_DISABLE)
      GUICtrlSetState($edit8, $GUI_DISABLE)
   EndIf
   GUICtrlSetLimit($edit8, 3, 1)

   $orgCatMax = IniRead($IniFile, $IniProgram, $IniCatMax, $CatDefaultMin)
   GUICtrlSetData($edit3, $orgCatMax)
   $orgUrlMax = IniRead($IniFile, $IniProgram, $IniUrlMax, $UrlDefaultMin)
   GUICtrlSetData($edit4, $orgUrlMax)

   GUISetState(@SW_SHOW, $dlg)


   ; 3. Get user input.
   $notDone = 1
   While $notDone
      $notDone2 = 1
      While $notDone2
         $msg = GUIGetMsg()

         Select
            Case $msg == $GUI_EVENT_CLOSE
               ; Close dialog
               ; 4. Exit if cancel.
               $notDone2 = 0
               $notDone = 0
               $retcode = 0
            Case $msg == $button1
               ; OK button
               $notDone2 = 0
            Case $msg == $button2
               ; Cancel button
               ; 4. Exit if cancel.
               $notDone2 = 0
               $notDone = 0
               $retcode = 0
            Case $msg == $button3
               ; Browse button
               GUISetState(@SW_DISABLE, $dlg)
               $newItem = FileOpenDialog($TitleBar & $TitleBrowse, @ScriptDir, "Executables (*.exe)", 1)
               If StringLen($newItem) Then
                  If StringInStr($newItem, @CommonFilesDir) Then
                     $tag = 1
                  ElseIf StringInStr($newItem, @ProgramFilesDir) Then
                     $tag = 1
                  ElseIf StringInStr($newItem, @SystemDir) Then
                     $tag = 1
                  ElseIf StringInStr($newItem, @WindowsDir) Then
                     $tag = 1
                  Else
                     $tag = 0
                  EndIf
                  If $tag Then
                     $text = "The program you have selected appears to be in a common Windows directory." & @CRLF
                     $text = $text & "Would you like to use a macro to define the path in an attempt to keep the" & @CRLF
                     $text = $text & "program system independant?" & @CRLF & @CRLF
                     $reply = MsgBox(4, $TitleBar & $TitleBrowse, $text)
                     If $reply == 6 Then $newItem = MacroEncode($newItem)
                  EndIf
                  GUICtrlSetData($edit2, $newItem)
               EndIf
               
               GUISetState(@SW_ENABLE, $dlg)
               GUISetState(@SW_HIDE, $dlg)
               GUISetState(@SW_SHOW, $dlg)
            Case $msg == $button4
               ; Paster Options button
               GUISetState(@SW_DISABLE, $dlg)
               PasterOptions()
               GUISetState(@SW_ENABLE, $dlg)
               GUISetState(@SW_HIDE, $dlg)
               GUISetState(@SW_SHOW, $dlg)
            Case $msg == $check7
               ; Enable/Disable Key Coding
               If GUICtrlRead($check7) == $GUI_UNCHECKED Then
                  GUICtrlSetState($check8, $GUI_DISABLE)
                  GUICtrlSetState($edit8, $GUI_DISABLE)
               Else
                  GUICtrlSetState($check8, $GUI_ENABLE)
                  If GUICtrlRead($check8) == $GUI_UNCHECKED Then
                     GUICtrlSetState($edit8, $GUI_DISABLE)
                  Else
                     GUICtrlSetState($edit8, $GUI_ENABLE)
                  EndIf
               EndIf
            Case $msg == $check8
               ; Enable/Disable Key Timeout
               If GUICtrlRead($check8) == $GUI_UNCHECKED Then
                  GUICtrlSetState($edit8, $GUI_DISABLE)
               Else
                  GUICtrlSetState($edit8, $GUI_ENABLE)
               EndIf
         EndSelect
      WEnd


      If $notDone Then
         ; 5. Validate data.
         GUISetState(@SW_DISABLE, $dlg)
         If GUICtrlRead($check7) == $GUI_CHECKED Then
            $newKeyEnable = 1
         Else
            $newKeyEnable = 0
         EndIf
         $newKeyTimeout = GUICtrlRead($edit8)

         $newCatMax = GUICtrlRead($edit3)
         $newUrlMax = GUICtrlRead($edit4)

         If GUICtrlRead($check7) == $GUI_CHECKED AND GUICtrlRead($check8) == $GUI_CHECKED Then
            If $newKeyTimeout < 5 OR $newKeyTimeout > 120 Then
               $newKeyTimeout = -1
            EndIf
         Else
            $newKeyTimeout = 0
         EndIf
       
         If $newKeyTimeout == -1 Then
            MsgBox(0, $TitleBar2, "Error - Invalid key timeout.  Must be between 5 and 120 minutes!")
            GUICtrlSetState($edit8, $GUI_FOCUS)
         ElseIf $newCatMax < $CatDefaultMin Then
            MsgBox(0, $TitleBar2, "Error - Caragory limit must be in the range of " & $CatDefaultMin & " to " & $CatDefaultMax &"!")
            GUICtrlSetState($edit3, $GUI_FOCUS)
         ElseIf $newCatMax > $CatDefaultMax Then
            MsgBox(0, $TitleBar2, "Error - Caragory limit must be in the range of " & $CatDefaultMin & " to " & $CatDefaultMax &"!")
            GUICtrlSetState($edit3, $GUI_FOCUS)
         ElseIf $newUrlMax < $UrlDefaultMin Then
            MsgBox(0, $TitleBar2, "Error - URL limit must be in the range of " & $UrlDefaultMin & " to " & $UrlDefaultMax &"!")
            GUICtrlSetState($edit4, $GUI_FOCUS)
         ElseIf $newUrlMax > $UrlDefaultMax Then
            MsgBox(0, $TitleBar2, "Error - URL limit must be in the range of " & $UrlDefaultMin & " to " & $UrlDefaultMax &"!")
            GUICtrlSetState($edit4, $GUI_FOCUS)
         Else
            ; 6. Warn if max values changed.
            If $newCatMax <> $orgCatMax OR $newUrlMax <> $orgUrlMax Then
               MsgBox(0, $TitleBar2, "Notice - Category and URL limits will not take effect until the next time you restart TryURL.")
            EndIf

            ; 7. Update INI file.
            ; Browser type
            If GUICtrlRead($radio1) == $GUI_CHECKED Then
               $BrowserType = $IniBrowserTypeDefault
            ElseIf GUICtrlRead($radio2) == $GUI_CHECKED Then
               $BrowserType = $IniBrowserTypeMSIE
            ElseIf GUICtrlRead($radio3) == $GUI_CHECKED Then
               $BrowserType = $IniBrowserTypeFirefox
            Else
               $BrowserType = $IniBrowserTypeOther
            EndIf
            If $orgBrowserType <> $BrowserType Then
               If $BrowserType == $IniBrowserTypeDefault Then
                  If IniDelete($IniFile, $IniProgram, $IniBrowserType) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating browser type!")
                  EndIf
                  LocateDefault()
               Else
                  If IniWrite($IniFile, $IniProgram, $IniBrowserType, $BrowserType) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating browser type!")
                  EndIf
               EndIf
            EndIf

            ; Browser title text
            $UserBrowserTitle = GUICtrlRead($edit1)
            If $orgBrowserTitle <> $UserBrowserTitle Then
               If StringLen($UserBrowserTitle) Then
                  If IniWrite($IniFile, $IniProgram, $IniBrowserTitle, $UserBrowserTitle) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating browser title text!")
                  EndIf
               Else
                  If IniDelete($IniFile, $IniProgram, $IniBrowserTitle) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating browser title text!")
                  EndIf
               EndIf
            EndIf

            ; Browser executable
            $UserBrowserProgram = GUICtrlRead($edit2)
            If $orgBrowserProgram <> $UserBrowserProgram Then
               If StringLen($UserBrowserProgram) Then
                  If IniWrite($IniFile, $IniProgram, $IniBrowserProgram, $UserBrowserProgram) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating browser executable!")
                  EndIf
               Else
                  If IniDelete($IniFile, $IniProgram, $IniBrowserProgram) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating browser executable!")
                  EndIf
               EndIf
               $UserBrowserExecutable = MacroDecode($UserBrowserProgram)
            EndIf

            ; Browser window class
            $UserBrowserWindowClass = GUICtrlRead($edit5)
            If $orgBrowserWindowClass <> $UserBrowserWindowClass Then
               If StringLen($UserBrowserWindowClass) Then
                  If IniWrite($IniFile, $IniProgram, $IniBrowserWindowClass, $UserBrowserWindowClass) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating browser window class!")
                  EndIf
               Else
                  If IniDelete($IniFile, $IniProgram, $IniBrowserWindowClass) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating browser window class!")
                  EndIf
               EndIf
            EndIf

            ; Browser input ID
            $UserBrowserInputID = GUICtrlRead($edit6)
            If $orgBrowserInputID <> $UserBrowserInputID Then
               If StringLen($UserBrowserInputID) Then
                  If IniWrite($IniFile, $IniProgram, $IniBrowserInputID, $UserBrowserInputID) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating browser input ID!")
                  EndIf
               Else
                  If IniDelete($IniFile, $IniProgram, $IniBrowserInputID) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating browser input ID!")
                  EndIf
               EndIf
            EndIf

            ; Category delete warning
            If GUICtrlRead($check1) == $GUI_CHECKED Then
               $WarnCatDelete = 1
            Else
               $WarnCatDelete = 0
            EndIf
            If $orgCatDelete <> $WarnCatDelete Then
               If IniWrite($IniFile, $IniProgram, $IniWarnCatDelete, $WarnCatDelete) <> 1 Then
                  MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating category delete warning!")
               EndIf
            EndIf

            ; Copy overwrite warning            
            If GUICtrlRead($check2) == $GUI_CHECKED Then
               $WarnOverwriteCopy = 1
            Else
               $WarnOverwriteCopy = 0
            EndIf
            If $orgOverwriteCopy <> $WarnOverwriteCopy Then
               If IniWrite($IniFile, $IniProgram, $IniWarnOverwriteCopy, $WarnOverwriteCopy) <> 1 Then
                  MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating URL copy overwrite warning!")
               EndIf
            EndIf

            ; Move overwrite warning
            If GUICtrlRead($check3) == $GUI_CHECKED Then
               $WarnOverwriteMove = 1
            Else
               $WarnOverwriteMove = 0
            EndIf
            If $orgOverwriteMove <> $WarnOverwriteMove Then
               If IniWrite($IniFile, $IniProgram, $IniWarnOverwriteMove, $WarnOverwriteMove) <> 1 Then
                  MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating URL move overwrite warning!")
               EndIf
            EndIf

            ; URL delete warning
            If GUICtrlRead($check4) == $GUI_CHECKED Then
               $WarnUrlDelete = 1
            Else
               $WarnUrlDelete = 0
            EndIf
            If $orgUrlDelete <> $WarnUrlDelete Then
               If IniWrite($IniFile, $IniProgram, $IniWarnUrlDelete, $WarnUrlDelete) <> 1 Then
                  MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating URL delete warning!")
               EndIf
            EndIf

            ; URL add overwrite warning
            If GUICtrlRead($check5) == $GUI_CHECKED Then
               $WarnOverwriteAdd = 1
            Else
               $WarnOverwriteAdd = 0
            EndIf
            If $orgOverwriteAdd <> $WarnOverwriteAdd Then
               If IniWrite($IniFile, $IniProgram, $IniWarnOverwriteAdd, $WarnOverwriteAdd) <> 1 Then
                  MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating URL add overwrite warning!")
               EndIf
            EndIf

            ; URL edit overwrite warning
            If GUICtrlRead($check6) == $GUI_CHECKED Then
               $WarnOverwriteEdit = 1
            Else
               $WarnOverwriteEdit = 0
            EndIf
            If $orgOverwriteEdit <> $WarnOverwriteEdit Then
               If IniWrite($IniFile, $IniProgram, $IniWarnOverwriteEdit, $WarnOverwriteEdit) <> 1 Then
                  MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating URL edit overwrite warning!")
               EndIf
            EndIf

            ; Key Encoding
            If $orgKeyEnable <> $newKeyEnable Then
               If $newKeyEnable Then
                  If EnableKeyCoding() Then
                     If IniWrite($IniFile, $IniProgram, $IniKeyEnable, $newKeyEnable) <> 1 Then
                        MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating key enable!")
                     EndIf
                     If IniWrite($IniFile, $IniProgram, $IniKeyTimeout, $newKeyTimeout) <> 1 Then
                        MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating key timeout!")
                     EndIf
                     $KeyEnable = $newKeyEnable
                     $KeyTimeout = $newKeyTimeout
                  EndIf
               Else
                  If DisableKeyCoding() Then
                     If IniDelete($IniFile, $IniProgram, $IniKeyEnable) <> 1 Then
                        MsgBox(0, $TitleBar2, "Error - Delete failure in INI file while updating key enable!")
                     EndIf
                     IniDelete($IniFile, $IniProgram, $IniKeyTimeout)
                     $KeyEnable = $newKeyEnable
                     $KeyTimeout = 0
                  EndIf
               EndIf
            ElseIf $orgKeyTimeout <> $newKeyTimeout Then
               If $newKeyTimeout Then
                  If IniWrite($IniFile, $IniProgram, $IniKeyTimeout, $newKeyTimeout) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating key timeout!")
                  EndIf
               Else
                  If IniDelete($IniFile, $IniProgram, $IniKeyTimeout) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Delete failure in INI file while updating key enable!")
                  EndIf
               EndIf
               $KeyTimeout = $newKeyTimeout
            EndIf

            ; Category limit
            If $orgCatMax <> $newCatMax Then
               If $newCatMax == $CatDefaultMin Then
                  If IniDelete($IniFile, $IniProgram, $IniCatMax) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating category limit!")
                  EndIf
               Else
                  If IniWrite($IniFile, $IniProgram, $IniCatMax, $newCatMax) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating category limit!")
                  EndIf
               EndIf
            EndIf

            ; URL limit
            If $orgUrlMax <> $newUrlMax Then
               If $newUrlMax == $UrlDefaultMin Then
                  If IniDelete($IniFile, $IniProgram, $IniUrlMax) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating URL limit!")
                  EndIf
               Else
                  If IniWrite($IniFile, $IniProgram, $IniUrlMax, $newUrlMax) <> 1 Then
                     MsgBox(0, $TitleBar2, "Error - Write failure in INI file while updating URL limit!")
                  EndIf
               EndIf
            EndIf

            $NotDone = 0
         EndIf

         GUISetState(@SW_ENABLE, $dlg)
         GUISetState(@SW_HIDE, $dlg)
         GUISetState(@SW_SHOW, $dlg)
      EndIf
   WEnd
   

   ; 8. Exit all done.
   GUIDelete($dlg)
   Return($retcode)
EndFunc


;
; PasterOptions()
; Entry:       <None>
; Return:      <None>
; Procedure:   1. Build the dialog. 
;              2. Populate data. 
;              3. Get user input.
;              4. Exit if cancel.
;              5. Validate data.
;              6. Update INI file.
;              7. Exit all done.
;
; WORK HERE - DDE SUpport?

Func  PasterOptions()
   Local    $dlg
   Local    $group1
   Local    $check1
   Local    $check2a, $check2b, $check2c
   Local    $check3a, $check3b, $check3c
   Local    $check4a, $check4b, $check4c
   Local    $combo1, $combo2, $combo3
   Local    $button1, $button2
   Local    $orgEnable
   Local    $orgLogin, $orgPaswd, $orgExit
   Local    $ctrl, $alt, $shift, $key
   Local    $list
   Local    $index, $notDone, $notDone2, $msg

   ; 1. Create the dialog.
   $retcode = 1
   $dlg = GUICreate($TitleBar & $TitlePaster, 350, 250)
   $group1 = GUICtrlCreateGroup($TextHotKeys, 20, 15, 311, 120)
   GUICtrlCreateLabel($TextPLogin, 35, 37, 80, 20)
   $check2a = GUICtrlCreateCheckbox($TextCtrl, 122, 35, 40, 20)
   $check2b = GUICtrlCreateCheckbox($TextAlt, 168, 35, 40, 20)
   $check2c = GUICtrlCreateCheckbox($TextShift, 209, 35, 40, 20)
   $combo1 = GUICtrlCreateCombo("", 262, 35, 55, 200)
   GUICtrlCreateLabel($TextPPaswd, 35, 67, 80, 20)
   $check3a = GUICtrlCreateCheckbox($TextCtrl, 122, 65, 40, 20)
   $check3b = GUICtrlCreateCheckbox($TextAlt, 168, 65, 40, 20)
   $check3c = GUICtrlCreateCheckbox($TextShift, 209, 65, 40, 20)
   $combo2 = GUICtrlCreateCombo("", 262, 65, 55, 200)
   GUICtrlCreateLabel($TextPExit, 35, 97, 80, 20)
   $check4a = GUICtrlCreateCheckbox($TextCtrl, 122, 95, 40, 20)
   $check4b = GUICtrlCreateCheckbox($TextAlt, 168, 95, 40, 20)
   $check4c = GUICtrlCreateCheckbox($TextShift, 209, 95, 40, 20)
   $combo3 = GUICtrlCreateCombo("", 262, 95, 55, 200)
   $check1 = GUICtrlCreateCheckbox($TextEnable, 115, 153, 150, 20)
   $button1 = GUICtrlCreateButton($TextOK, 85, 192, 80, 30)
   $button2 = GUICtrlCreateButton($TextCancel, 185, 192, 80, 30)
   GUICtrlSetState($button1, $GUI_DEFBUTTON)


   ; 2. Populate data.

   $orgEnable = IniRead($IniFile, $IniPasterSection, $IniPasterEnable,  0)
   If $orgEnable Then
      GUICtrlSetState($check1, $GUI_CHECKED)
   Else
      GUICtrlSetState($check1, $GUI_CHECKED)
   EndIf

   $list = $RECSEP & "None"
   For $index = 1 To 12
      $list &= $RECSEP & "F" & $index
   Next
   $list &= $RECSEP & "HOME" & $RECSEP & "END" & $RECSEP & "INS"
   $list &= $RECSEP & "DEL" & $RECSEP & "PGUP" & $RECSEP & "PGDN"
   $list &= $RECSEP & "TAB"
   For $index = 0 To 9
      $list &= $RECSEP & $index
   Next
   For $index = 0 To 25
      $list &= $RECSEP & Chr($index + 65)
   Next

   $orgLogin = IniRead($IniFile, $IniPasterSection, $IniLoginHotKey,  "")
   $ctrl = 0
   $alt = 0
   $shift = 0
   $key = ""
   $index = 1
   While $index <= StringLen($orgLogin)   
      If StringMid($orgLogin, $index, 1) == "^" Then
         $ctrl = 1
      ElseIf StringMid($orgLogin, $index, 1) == "!" Then
         $alt = 1
      ElseIf StringMid($orgLogin, $index, 1) == "+" Then
         $shift = 1
      Else
         $key = StringMid($orgLogin, $index)
         ExitLoop
      EndIf
      $index += 1
   WEnd
   If $ctrl Then
      GUICtrlSetState($check2a, $GUI_CHECKED)
   Else
      GUICtrlSetState($check2a, $GUI_UNCHECKED)
   EndIf
   If $alt Then
      GUICtrlSetState($check2b, $GUI_CHECKED)
   Else
      GUICtrlSetState($check2b, $GUI_UNCHECKED)
   EndIf
   If $shift Then
      GUICtrlSetState($check2c, $GUI_CHECKED)
   Else
      GUICtrlSetState($check2c, $GUI_UNCHECKED)
   EndIf
   GUICtrlSetData($combo1, $list)
   If StringLen($key) > 1 Then
      $key = StringMid($key, 2, StringLen($key) - 2)
   EndIf
   If StringInStr($list, $key) <> 0 Then
      GUICtrlSetData($combo1, $key)
   Else
      GUICtrlSetData($combo1, "None")
   EndIf

   $orgPaswd = IniRead($IniFile, $IniPasterSection, $IniPaswdHotKey,  "")
   $ctrl = 0
   $alt = 0
   $shift = 0
   $key = ""
   $index = 1
   While $index <= StringLen($orgPaswd)   
      If StringMid($orgPaswd, $index, 1) == "^" Then
         $ctrl = 1
      ElseIf StringMid($orgPaswd, $index, 1) == "!" Then
         $alt = 1
      ElseIf StringMid($orgPaswd, $index, 1) == "+" Then
         $shift = 1
      Else
         $key = StringMid($orgPaswd, $index)
         ExitLoop
      EndIf
      $index += 1
   WEnd
   If $ctrl Then
      GUICtrlSetState($check3a, $GUI_CHECKED)
   Else
      GUICtrlSetState($check3a, $GUI_UNCHECKED)
   EndIf
   If $alt Then
      GUICtrlSetState($check3b, $GUI_CHECKED)
   Else
      GUICtrlSetState($check3b, $GUI_UNCHECKED)
   EndIf
   If $shift Then
      GUICtrlSetState($check3c, $GUI_CHECKED)
   Else
      GUICtrlSetState($check3c, $GUI_UNCHECKED)
   EndIf
   GUICtrlSetData($combo2, $list)
   If StringLen($key) > 1 Then
      $key = StringMid($key, 2, StringLen($key) - 2)
   EndIf
   If StringInStr($list, $key) <> 0 Then
      GUICtrlSetData($combo2, $key)
   Else
      GUICtrlSetData($combo2, "None")
   EndIf

   $orgExit = IniRead($IniFile, $IniPasterSection, $IniExitHotKey,  "")
   $ctrl = 0
   $alt = 0
   $shift = 0
   $key = ""
   $index = 1
   While $index <= StringLen($orgExit)   
      If StringMid($orgExit, $index, 1) == "^" Then
         $ctrl = 1
      ElseIf StringMid($orgExit, $index, 1) == "!" Then
         $alt = 1
      ElseIf StringMid($orgExit, $index, 1) == "+" Then
         $shift = 1
      Else
         $key = StringMid($orgExit, $index)
         ExitLoop
      EndIf
      $index += 1
   WEnd
   If $ctrl Then
      GUICtrlSetState($check4a, $GUI_CHECKED)
   Else
      GUICtrlSetState($check4a, $GUI_UNCHECKED)
   EndIf
   If $alt Then
      GUICtrlSetState($check4b, $GUI_CHECKED)
   Else
      GUICtrlSetState($check4b, $GUI_UNCHECKED)
   EndIf
   If $shift Then
      GUICtrlSetState($check4c, $GUI_CHECKED)
   Else
      GUICtrlSetState($check4c, $GUI_UNCHECKED)
   EndIf
   GUICtrlSetData($combo3, $list)
   If StringLen($key) > 1 Then
      $key = StringMid($key, 2, StringLen($key) - 2)
   EndIf
   If StringInStr($list, $key) <> 0 Then
      GUICtrlSetData($combo3, $key)
   Else
      GUICtrlSetData($combo3, "None")
   EndIf

   GUISetState(@SW_SHOW, $dlg)


   ; 3. Get user input.
   $notDone = 1
   While $notDone
      $notDone2 = 1
      While $notDone2
         $msg = GUIGetMsg()

         Select
            Case $msg == $GUI_EVENT_CLOSE
               ; Close dialog
               ; 4. Exit if cancel
               $notDone2 = 0
               $notDone = 0
            Case $msg == $button1
               ; OK button
               $notDone2 = 0
            Case $msg == $button2
               ; Cancel button
               ; 4. Exit if cancel.
               $notDone2 = 0
               $notDone = 0
         EndSelect
      WEnd


      ; 5. Validate data.
      If $notDone Then
         GUISetState(@SW_DISABLE, $dlg)
         $key = GUICtrlRead($combo1)
         If StringInStr($list, $key) == 0 OR StringInStr($key, $RECSEP) Then
            MsgBox(0, $TitleBar, "Error - Invalid " & Chr(34) & "Paste Login" & Chr(34) & " HotKey!")
            GUICtrlSetData($check2a, $GUI_UNCHECKED)
            GUICtrlSetData($check2b, $GUI_UNCHECKED)
            GUICtrlSetData($check2c, $GUI_UNCHECKED)
            GUICtrlSetData($combo1, "None")
            GUICtrlSetState($combo1, $GUI_FOCUS)
         Else
            $key = GUICtrlRead($combo2)
            If StringInStr($list, $key) == 0 OR StringInStr($key, $RECSEP) Then
               MsgBox(0, $TitleBar, "Error - Invalid " & Chr(34) & "Paste Password" & Chr(34) & " HotKey!")
               GUICtrlSetData($check3a, $GUI_UNCHECKED)
               GUICtrlSetData($check3b, $GUI_UNCHECKED)
               GUICtrlSetData($check3c, $GUI_UNCHECKED)
               GUICtrlSetData($combo2, "None")
               GUICtrlSetState($combo2, $GUI_FOCUS)
            Else
               $key = GUICtrlRead($combo1)
               If StringInStr($list, $key) == 0 OR StringInStr($key, $RECSEP) Then
                  MsgBox(0, $TitleBar, "Error - Invalid " & Chr(34) & "Exit Program" & Chr(34) & " HotKey!")
                  GUICtrlSetData($check4a, $GUI_UNCHECKED)
                  GUICtrlSetData($check4b, $GUI_UNCHECKED)
                  GUICtrlSetData($check4c, $GUI_UNCHECKED)
                  GUICtrlSetData($combo3, "None")
                  GUICtrlSetState($combo3, $GUI_FOCUS)
               Else
                  ; 6. Update INI file.
                  $key = 0
                  If GUICtrlRead($check1) == $GUI_CHECKED Then $key = 1
                  If $key <> $orgEnable Then
                     If IniWrite($IniFile, $IniPasterSection, $IniPasterEnable, $key) <> 1 Then
                        MsgBox(0, $TitleBar, "Error - Failure writing Paster Enable value to Ini file!")
                     EndIf
                  EndIf
         
                  $key = ""
                  If GUICtrlRead($combo1) <> "None" Then
                     If GUICtrlRead($check2a) == $GUI_CHECKED Then $key &= "^"
                     If GUICtrlRead($check2b) == $GUI_CHECKED Then $key &= "!"
                     If GUICtrlRead($check2c) == $GUI_CHECKED Then $key &= "+"
                     If StringLen(GUICtrlRead($combo1)) == 1 Then
                        $key &= GUICtrlRead($combo1)
                     Else
                        $key &= "{" & GUICtrlRead($combo1) & "}"
                     EndIf
                  EndIf
                  If $key <> $orgLogin Then
                     If IniWrite($IniFile, $IniPasterSection, $IniLoginHotKey, $key) <> 1 Then
                        MsgBox(0, $TitleBar, "Error - Failure writing Login HotKey value to Ini file!")
                     EndIf
                  EndIf
         
                  $key = ""
                  If GUICtrlRead($combo2) <> "None" Then
                     If GUICtrlRead($check3a) == $GUI_CHECKED Then $key &= "^"
                     If GUICtrlRead($check3b) == $GUI_CHECKED Then $key &= "!"
                     If GUICtrlRead($check3c) == $GUI_CHECKED Then $key &= "+"
                     If StringLen(GUICtrlRead($combo2)) == 1 Then
                        $key &= GUICtrlRead($combo2)
                     Else
                        $key &= "{" & GUICtrlRead($combo2) & "}"
                     EndIf
                  EndIf
                  If $key <> $orgPaswd Then
                     If IniWrite($IniFile, $IniPasterSection, $IniPaswdHotKey, $key) <> 1 Then
                        MsgBox(0, $TitleBar, "Error - Failure writing Password HotKey value to Ini file!")
                     EndIf
                  EndIf
         
                  $key = ""
                  If GUICtrlRead($combo3) <> "None" Then
                     If GUICtrlRead($check4a) == $GUI_CHECKED Then $key &= "^"
                     If GUICtrlRead($check4b) == $GUI_CHECKED Then $key &= "!"
                     If GUICtrlRead($check4c) == $GUI_CHECKED Then $key &= "+"
                     If StringLen(GUICtrlRead($combo3)) == 1 Then
                        $key &= GUICtrlRead($combo3)
                     Else
                        $key &= "{" & GUICtrlRead($combo3) & "}"
                     EndIf
                  EndIf
                  If $key <> $orgExit Then
                     If IniWrite($IniFile, $IniPasterSection, $IniExitHotKey, $key) <> 1 Then
                        MsgBox(0, $TitleBar, "Error - Failure writing Program Exit HotKey value to Ini file!")
                     EndIf
                  EndIf
         
                  $notDone = 0
               EndIf
            EndIf
         EndIf
      EndIf

      GUISetState(@SW_ENABLE, $dlg)
      GUISetState(@SW_HIDE, $dlg)
      GUISetState(@SW_SHOW, $dlg)
   WEnd


   ; 7. Exit all done.
   GUIDelete($dlg)
   Return(0)
EndFunc


;
; User Defined Functions
; Main Menu Functions
;

;
; AddURL()
; Entry:       <None>
; Return:      <None>
; Procedure:   1. Look for open broser by class, goto 3 if found.
;              2. Look for open browser by title, goto 5 if not found.
;              3. Copy URL from open browser.
;              4. Extract site name from browser.
;              5. Run the dialog.
;              6, Exit all done.
;
; WORK HERE - DDE Support?

Func  AddURL()
   Local    $left, $right, $pos, $text
   Local    $program, $directory, $findClass, $findTitle, $inputID, $keys
   Local    $find, $matchTitle, $matchUrl, $matchName
   
   ; 1. Look for open broser by class, goto 3 if found.
   AutoItSetOption("WinTitleMatchMode", 4)
   $matchTitle = ""
   $matchUrl = ""
   $matchName = ""
   $left = ""
   $right = ""
   Select
      Case  $BrowserType == $IniBrowserTypeDefault
         $program = $SystemProgram
         $directory = $SystemDirectory
         $findClass = $SystemWindowClass
         $findTitle = $SystemTitle
         $inputID = $SystemInputID
         $keys = $SystemCopyKeys
      Case  $BrowserType == $IniBrowserTypeMSIE
         $program = $IEProgram
         $directory = $IEDirectory
         $findClass = $IEWindowClass
         $findTitle = $IETitle
         $inputID = $IEInputID
         $keys = $IECopyKeys
      Case  $BrowserType == $IniBrowserTypeFirefox
         $program = $FirefoxProgram
         $directory = $FirefoxDirectory
         $findClass = $FirefoxWindowClass
         $findTitle = $FirefoxTitle
         $inputID = $FirefoxInputID
         $keys = $FirefoxCopyKeys
      Case  $BrowserType == $IniBrowserTypeOther
         $program = $UserBrowserExecutable
         $directory = $UserBrowserDirectory
         $findClass = $UserBrowserWindowClass
         $findTitle = $UserBrowserTitle
         $inputID = $UserBrowserInputID
         If StringLen($inputID) == 0 OR $inputID == "NULL" Then
            $keys = $DefaultNoInputIDCopyKeys
         Else
            $keys = $DefaultCopyKeys
         EndIf
   EndSelect

   ; User specified settiong always overrides
   If StringLen($UserBrowserWindowClass) Then
      $findClass = $UserBrowserWindowClass
   EndIf

   ; Do the search
   If StringLen($findClass) Then
      $matchTitle = WinGetTitle($SearchClass & $findClass)
      If $matchTitle == 0 Then
         $matchTitle = ""
      EndIf
   EndIf


   ; 2. Look for open browser by title, goto 4 if not found.
   ; User supplied value always overrides
   If StringLen($UserBrowserTitle) Then
      $findTitle = $UserBrowserTitle
   EndIf

   If StringLen($findTitle) Then
      If StringInStr($findTitle, $MacroURL) Then
         $left = StringLeft($findTitle, StringInStr($findTitle, $MacroURL) - 1)
         $right = StringMid($findTitle, StringInStr($findTitle, $MacroURL) + StringLen($MacroURL))

         If StringLen($left) Then
            $find = $SearchCmd & $SearchLeft1 & $left & $SearchLeft2
         Else
            $find = $SearchCmd
         EndIf
         $find = $find & $SearchMid

         If StringLen($right) Then
            $find = $find & $SearchRight1 & $right & $SearchRight2
         EndIf

         If StringLen($matchTitle) == 0 Then
            $matchTitle = WinGetTitle($find)
            If $matchTitle == 0 Then
               $matchTitle = ""
            EndIf
         EndIf
      EndIf
   EndIf


   ; 3. Copy URL from open browser.
   If StringLen($findTitle) == 0 Then
      If $WarnNoTitle Then
         $text = "WARNING! - There is no browser title text defined.  Without the title text TrayURL" & @CRLF
         $text = $text & "will have problems extracting the web site description from your browser.  You should" & @CRLF
         $text = $text & "define the title text in the Options dialog.  Until that time, TrayURL will have problems" & @CRLF
         $text = $text & "extracting the web site description from your browser and you will have to manually" & @CRLF
         $text = $text & "enter it." & @CRLF & @CRLF
         $text = $text & "Do you wish to continue receiving these warnings?" & @CRLF & @CRLF
         $text = MsgBox(4, $TitleBar, $text)
         If $text <> 6 Then
            $WarnNoTitle = 0
         EndIf
      EndIf
   EndIf

   If StringLen($matchTitle) Then
      ; User specified value always overrides
      If StringLen($UserBrowserInputID) Then
         $inputID = $UserBrowserInputID
      EndIf

      WinActivate($matchTitle)
      If StringLen($inputID) AND $inputID <> "NULL" Then
         ClipPut("")
         ControlSend($matchTitle, "", $inputID, $keys)
         $matchUrl = ClipGet()
         If StringLen($matchUrl) == 0 Then
            ControlSend($matchTitle, "", $inputID, $keys)
            $matchUrl = ClipGet()
         EndIf
      Else
         If $WarnNoInputID AND StringLen($inputID) == 0 Then
            $text = "WARNING! - There is no input ID defined.  Without the input ID TrayURL" & @CRLF
            $text = $text & "may not be able to copy the URL from your browser.  You should define an input" & @CRLF
            $text = $text & "ID in the Options dialog.  Until that time, TrayURL will be unable to copy" & @CRLF
            $text = $text & "the URL from your browser and you will have to manually copy it." & @CRLF & @CRLF
            $text = $text & "Do you wish to continue receiving these warnings?" & @CRLF & @CRLF
            $text = MsgBox(4, $TitleBar, $text)
            If $text <> 6 Then
               $WarnNoInputId = 0
            EndIf
            ClipPut("")
            Send($keys)
            Sleep(50)
            $matchUrl = ClipGet()
            If StringLen($matchUrl) == 0 Then
               Sleep(50)
               Send($keys)
               $matchUrl = ClipGet()
            EndIf
         EndIf
      EndIf


      ; 4, Extract site name from browser,
      If StringLen($left) == 0 AND StringLen($right) == 0 Then
         If StringLeft($matchTitle, StringLen($findTitle)) == $findTitle Then
            $matchName = StringMid($matchTitle, StringLen($findTitle))
         ElseIf StringRight($matchTitle, StringLen($findTitle)) == $findTitle Then
            $matchName = StringLeft($matchTitle, StringLen($matchTitle) - StringLen($findTitle))
         EndIf
      Else
         $matchName = StringMid($matchTitle, StringLen($left) + 1, StringLen($matchTitle) - (StringLen($left) + StringLen($right)))
      EndIf
   EndIf


   AutoItSetOption("WinTitleMatchMode", 1)
   AddUrlDialog($IniCatMain, $matchName, $matchUrl, "", "", 0, "", 1)
   Return(1)
EndFunc


;
; LaunchURL($url)
; Entry:       $url     URL to launch
; Return:      0 if fail
;              1 if success
; Procedure:   1. Look for open browser by class, goto 3 if found.
;              2. Look for open browser by title, goto 4 if not found.
;              3. Send URL to open browser and return.
;              4. If user specified browser in ini file, then use it.
;              5. If program does not exist then error.
;              6. Launch the browser with URL.
;              7. Exit all done.
;
; WORK HERE - DDE Support?

Func  LaunchURL($url)
   Local    $left, $right, $pos
   Local    $program, $directory, $findClass, $findTitle, $inputID
   Local    $find, $matchTitle, $text
   Local    $selectKeys, $copyKeys
   
   ; 1. Look for open broser by class, goto 3 if found.
   AutoItSetOption("WinTitleMatchMode", 4)
   $matchTitle = ""
   Select
      Case  $BrowserType == $IniBrowserTypeDefault
         $program = $SystemProgram
         $directory = $SystemDirectory
         $findClass = $SystemWindowClass
         $findTitle = $SystemTitle
         $inputID = $SystemInputID
         $selectKeys = $SystemSelectKeys
         $copyKeys = $SystemCopyKeys
      Case  $BrowserType == $IniBrowserTypeMSIE
         $program = $IEProgram
         $directory = $IEDirectory
         $findClass = $IEWindowClass
         $findTitle = $IETitle
         $inputID = $IEInputID
         $selectKeys = $IESelectKeys
         $copyKeys = $IECopyKeys
      Case  $BrowserType == $IniBrowserTypeFirefox
         $program = $FirefoxProgram
         $directory = $FirefoxDirectory
         $findClass = $FirefoxWindowClass
         $findTitle = $FirefoxTitle
         $inputID = $FirefoxInputID
         $selectKeys = $FirefoxSelectKeys
         $copyKeys = $FirefoxCopyKeys
      Case  $BrowserType == $IniBrowserTypeOther
         $program = $UserBrowserExecutable
         $directory = $UserBrowserDirectory
         $findClass = $UserBrowserWindowClass
         $findTitle = $UserBrowserTitle
         $inputID = $UserBrowserInputID
         If StringLen($inputID) == 0 OR $inputID == "NULL" Then
            $selectKeys = $DefaultNoInputIDSelectKeys
            $copyKeys = $DefaultNoInputIDCopyKeys
         Else
            $selectKeys = $DefaultSelectKeys
            $copyKeys = $DefaultCopyKeys
         EndIf
   EndSelect

   ; User specified settiong always overrides
   If StringLen($UserBrowserWindowClass) Then
      $findClass = $UserBrowserWindowClass
   EndIf

   ; Do the search
   If StringLen($findClass) Then
      $matchTitle = WinGetTitle($SearchClass & $findClass)
      If $matchTitle == 0 Then
         $matchTitle = ""
      EndIf
   EndIf


   ; 2. Look for open browser by title, goto 4 if not found.
   ; User supplied value always overrides
   If StringLen($matchTitle) == 0 Then
      If StringLen($UserBrowserTitle) Then
         $findTitle = $UserBrowserTitle
      EndIf

      If StringLen($findTitle) Then
         If StringInStr($findTitle, $MacroURL) Then
            $left = StringLeft($findTitle, StringInStr($findTitle, $MacroURL) - 1)
            $right = StringMid($findTitle, StringInStr($findTitle, $MacroURL) + StringLen($MacroURL))

            If StringLen($left) Then
               $find = $SearchCmd & $SearchLeft1 & $left & $SearchLeft2
            Else
               $find = $SearchCmd
            EndIf
            $find = $find & $SearchMid

            If StringLen($right) Then
               $find = $find & $SearchRight1 & $right & $SearchRight2
            EndIf

            $matchTitle = WinGetTitle($find)
            If $matchTitle == 0 Then
               $matchTitle = ""
            EndIf
         EndIf
      EndIf
   EndIf


   ; 3. Send URL to open browser and return.
   If StringLen($matchTitle) Then
      ; User specified value always overrides
      If StringLen($UserBrowserInputID) Then
         $inputID = $UserBrowserInputID
      EndIf

      WinActivate($matchTitle)
      If StringLen($inputID) AND $inputID <> "NULL" Then
         ClipPut("")
         ControlSend($matchTitle, "", $inputID, $copyKeys)
         If StringLen(ClipGet()) == 0 Then
            ControlSend($matchTitle, "", $inputID, $selectKeys)
         EndIf
         ControlSend($matchTitle, "", $inputID, $url & @CR)
         Sleep(500)
      Else
         If $WarnNoInputID AND StringLen($inputID) == 0 Then
            $text = "WARNING! - There is no input ID defined.  Without the input ID TrayURL" & @CRLF
            $text = $text & "may not be able to send the URL to your browser.  You should define an input" & @CRLF
            $text = $text & "ID in the Options dialog.  Until that time, TrayURL will only copy the URL" & @CRLF
            $text = $text & "to the system clipboard and you can paste it into the browser." & @CRLF & @CRLF
            $text = $text & "Do you wish to continue receiving these warnings?" & @CRLF & @CRLF
            $text = MsgBox(4, $TitleBar, $text)
            If $text <> 6 Then
               $WarnNoInputId = 0
            EndIf
            ClipPut("")
            Send($copyKeys)
            Sleep(50)
            $text = ClipGet()
            If StringLen($text) == 0 Then
               Send($selectKeys)
               Sleep(50)
            EndIf
            Send($url & @CR)
            ClipPut($url)
         EndIf
         AutoItSetOption("WinTitleMatchMode", 1)
         Return(0)
      EndIf
      AutoItSetOption("WinTitleMatchMode", 1)
      Return(1)
   EndIf
   AutoItSetOption("WinTitleMatchMode", 1)


   ; 4. If user specified browser in ini file, then goto 6.
   If StringLen($UserBrowserExecutable) Then
      $program = $UserBrowserExecutable
   EndIf


   ; 5. If program does not exist then error.
   If StringLen($program) == 0 Then
      If $WarnNoBrowser Then
         $text = "WARNING! - There is no browser program defined.  Without the browserprogram," & @CRLF
         $text = $text & "TrayURL cannot launch your browser.  You should define a browser in the Options" & @CRLF
         $text = $text & "dialog.  Until that time, TrayURL will only copy the URL to the system clipboard and" & @CRLF
         $text = $text & "you can launch your browser manually and paste the URL into it." & @CRLF & @CRLF
         $text = $text & "Do you wish to continue receiving these warnings?" & @CRLF & @CRLF
         $text = MsgBox(4, $TitleBar, $text)
         If $text <> 6 Then
            $WarnNoBrowser = 0
         EndIf
         ClipPut($url)
      EndIf
      Return(0)
   ElseIf FileExists($program) <> 1 Then
      MsgBox(0, $TitleBar, "Error - Browser " & $program & " not found!")
      Return(0)
   EndIf


   ; 6. Launch the browser with URL.
   AutoItSetOption("RunErrorsFatal", 0)
   Run(Chr(34) & $program & Chr(34) & " " & Chr(34) & $url & Chr(34), $directory)
   If @error Then
      MsgBox(0, $TitleBar2, "Error - Can't run " & $program & "!")
      Return(0)
   EndIf


   ; 7. Exit all done.
   Return(1)
EndFunc


;
; User Defined Functions
; Support Utilities
;

;
; LaunchPaster($login, $paswd, $flags)
; Entry:       $login      User login
;              $paswd      User password
; Return:      0 if fail
;              1 if success
; Procedure:   1. Verify paster is enabled, return if not.
;              2. Decode if needed.
;              3. Build command line.
;              4. Launch the paster, report if error. 
;              5. Exit all done.
;

Func  LaunchPaster($login, $paswd, $flags)
   Local    $enable, $cmd, $loginText, $paswdText
   
   ; 1. Verify paster is enabled, return if not.
   $enable = Number(IniRead($IniFile, $IniPasterSection, $IniPasterEnable, 0))
   If $enable == 0 Then Return(1)


   ; 2. Decode if needed.
   If $KeyEnable Then
      If StringLen($login) Then
         $loginText = KeyDecode($login)
         If StringLen($loginText) == 0 Then Return(0)
      Else
         $loginText = $login 
      EndIf

      If StringLen($paswd) Then
         $paswdText = KeyDecode($paswd)
         If StringLen($paswdText) == 0 Then Return(0)
      Else
         $paswdText = $paswd 
      EndIf
   Else
      $loginText = $login
      $paswdText = $paswd
   EndIf


   ; 3. Build command line.
   $cmd = Chr(34) & @ScriptDir
   If StringRight($cmd, 1) <> "\" Then $cmd &= "\"
   $cmd &= $PasterProgram & Chr(34) & " "
   $cmd &= Chr(34) & $IniFile & Chr(34) & " "
   $cmd &= Chr(34) & $loginText & Chr(34) & " "
   $cmd &= Chr(34) & $paswdText & Chr(34) & " "
   $cmd &= $flags

   ; 4. Launch the paster, report if error. 
   AutoItSetOption("RunErrorsFatal", 0)
   Run($cmd)
   If @error Then
      MsgBox(0, $TitleBar, "Error - Failure launching Paster utility!")
      Return(0)
   EndIf


   ; 5. Exit all done.
   Return(1)
EndFunc


;
; User Defined Functions
; Browser Support
;

;
; LocateMSIE($file)
; Entry:       $file       File to check if it is MSIE       
; Return:      Browser installation status
; Procedure:   1. Check if the passed in file is present.
;              2. Check if it is in default install directory.
;              3. Check registry entries for location.
;              4. Fill in data structures.
;              5. Exit all done.
; NOTE:  This function contains specific registry entry keys/  Be careful
;        if you change these.
;
Func  LocateMSIE($file)
   Local    $text, $pos
   Local    $regKey, $regName

   ; 1, Check if the passed in file is present.
   $IEProgram = ""
   If StringLen($file) Then
      If FileExists($file) Then
         $IEProgram = $file
      EndIf
   EndIf
  
   ; 2. Check if it is in default install directory.
   If StringLen($IEProgram) == 0 Then
      $text = @ProgramFilesDir
      If StringRight($text, 1) == "\" Then
         $text = $text & $DefaultIEProgram
      Else
         $text = $text & "\" & $DefaultIEProgram
      EndIf

      If FileExists($text) == 1 Then
         $IEProgram = $text
      EndIf
   EndIf


  ; 3. Check registry entries for location.
  If StringLen($IEProgram) == 0 Then
      $regKey = "HKEY_CLASSES_ROOT\InternetExplorer.Application\CLSID"
      $regName = ""
      $text = RegRead($regKey, $regName)
      If StringLen($text) Then
         $regKey = "HKEY_CLASSES_ROOT\CLSID\" & $text & "\LocalServer32"
         $regName = ""
         $text = RegRead($regKey, $regName)
         $pos = StringInStr($text, ".exe", 0, -1)
         If $pos Then
            $text = StringLeft($text, $pos + 3)
            If StringLeft($text, 1) == Chr(34) Then
               $text = StringMid($text, 2)
            EndIf
            If FileExists($text) == 1 Then
               $IEProgram = $text
            EndIf
         EndIf
      EndIf
      

      If StringLen($IEProgram) == 0 Then
         $regKey = "HKEY_CLASSES_ROOT\Applications\iexplore.exe\shell\open\command"
         $regName = ""
         $text = RegRead($regKey, $regName)
         $pos = StringInStr($text, ".exe", 0, -1)
         If $pos Then
            $text = StringLeft($text, $pos + 3)
            If StringLeft($text, 1) == Chr(34) Then
               $text = StringMid($text, 2)
            EndIf
            If FileExists($text) == 1 Then
               $IEProgram = $text
            EndIf
         EndIf
      EndIf
   EndIf


   ; 4. Fill in data structures.
   If StringLen($IEProgram) Then
      $IEEnable = 1
      $IEDirectory = GetDirectory($IEProgram)
      $IETitle = $DefaultIETitle
      $IEWindowClass = $DefaultIEWindowClass
      $IEInputID = $DefaultIEInputID
      $IESelectKeys = $DefaultIESelectKeys
      $IECopyKeys = $DefaultIECopyKeys
   Else
      ; Switch if this is the active browser type
      If $BrowserType == $IniBrowserTypeMSIE Then
         MsgBox(0, $TitleBar2, "Error - Cab't locate MSIE browser.  Setting browser type to System Default!")
         $BrowserType = $IniBrowserTypeDefault
      EndIf
      
      $IEEnable = 0
      $IEDirectory = ""
      $IETitle = ""
      $IEWindowCLass = ""
      $IEInputID = ""
      $IESelectKeys = ""
      $IECopyKeys = ""
   EndIf
   
   
   ; 5. Exit all done.
   Return($IEEnable)
EndFunc


;
; LocateFirefox($file)
; Entry:       $file       File to check if Firefox       
; Return:      Browser installation status
; Procedure:   1, Check if the passed in file is present.
;              2. Check if it is in default install directory.
;              3. Check registry entries for location.
;              4. Fill in data structures.
;              5. Exit all done.
; NOTE:  This function contains specific registry entry keys/  Be careful
;        if you change these.
;
Func  LocateFirefox($file)
   Local    $text, $pos
   Local    $regKey, $regName

   ; 1, Check if the passed in file is present.
   $FirefoxProgram = ""
   If StringLen($file) Then
      If FileExists($file) Then
         $FirefoxProgram = $file
      EndIf
   EndIf
  
   ; 2. Check if it is in default install directory.
   If StringLen($FirefoxProgram) == 0 Then
      $text = @ProgramFilesDir
      If StringRight($text, 1) == "\" Then
         $text = $text & $DefaultFirefoxProgram
      Else
         $text = $text & "\" & $DefaultFirefoxProgram
      EndIf

      If FileExists($text) == 1 Then
         $FirefoxProgram = $text
      EndIf
   EndIf
   
   ; 3. Check registry entries for location.
   If StringLen($FirefoxProgram) == 0 Then
      $regKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\firefox.exe"
      $regName = ""
      $text = RegRead($regKey, $regName)
      If StringLen($text) Then
         $pos = StringInStr($text, ".exe", 0, -1)
         If $pos Then
            $text = StringLeft($text, $pos + 3)
            If StringLeft($text, 1) == Chr(34) Then
               $text = StringMid($text, 2)
            EndIf
            If FileExists($text) == 1 Then
               $FirefoxProgram = $text
            EndIf
         EndIf
      EndIf
      

      If StringLen($FirefoxProgram) == 0 Then
         $regKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Clients\StartMenuInternet\FIREFOX.EXE\shell\open\command"
         $regName = ""
         $text = RegRead($regKey, $regName)
         $pos = StringInStr($text, ".exe", 0, -1)
         If $pos Then
            $text = StringLeft($text, $pos + 3)
            If StringLeft($text, 1) == Chr(34) Then
               $text = StringMid($text, 2)
            EndIf
            If FileExists($text) == 1 Then
               $FirefoxProgram = $text
            EndIf
         EndIf
      EndIf
   EndIf


   ; 4. Fill in data structures.
   If StringLen($FirefoxProgram) Then
      $FirefoxEnable = 1
      $FirefoxDirectory = GetDirectory($FirefoxProgram)
      $FirefoxTitle = $DefaultFirefoxTitle
      $FirefoxWindowCLass = $DefaultFirefoxWindowClass
      $FirefoxInputID = $DefaultFirefoxInputID
      $FirefoxSelectKeys = $DefaultFirefoxSelectKeys
      $FirefoxCopyKeys = $DefaultFirefoxCopyKeys
   Else
      ; Switch if this is the active browser type
      If $BrowserType == $IniBrowserTypeFirefox Then
         MsgBox(0, $TitleBar2, "Error - Cab't locate Firefox browser.  Setting browser type to System Default!")
         $BrowserType = $IniBrowserTypeDefault
      EndIf
      
      $FirefoxEnable = 0
      $FirefoxDirectory = ""
      $FirefoxTitle = ""
      $FirefoxWindowCLass = ""
      $FirefoxInputID = ""
      $FirefoxSelectKeys = ""
      $FirefoxCopyKeys = ""
   EndIf
   

   ; 5. Exit all done.
   Return($FirefoxEnable)
EndFunc


;
; LocateDefault()
; Entry:       <None>       
; Return:      <None>
; Procedure:   1. Check registry entriy for location.
;              2. Determin browser type.
;              3. If MSIE then
;                 a) If MSIE is disabled then enable it.
;                 b) Set data values.
;              4. If Firefox then
;                 a) If Firefox is disabled then enable it.
;                 b) Set data values.
;              5. If Other then
;                 a) Set data values.
;              6. Exit all done.
; NOTE:        This function assumes that LocateMSIE() and
;              LocateFirefox() have been called prior to this
;              function.
; NOTE:        This function contains specific registry entry keys,
;              Be careful if you change these.
;
Func  LocateDefault()
   Local    $text, $pos
   Local    $regKey, $regName
   Local    $type

   ; 1. Check registry entry for location.
   $SystemProgram = ""
   $regKey = "HKEY_LOCAL_MACHINE\SOFTWARE\CLASSES\http\shell\open\command"
   $regName = ""
   $text = RegRead($regKey, $regName)
   $pos = StringInStr($text, ".exe", 0, -1)
   If $pos Then
      $text = StringLeft($text, $pos + 3)
      If StringLeft($text, 1) == Chr(34) Then
         $text = StringMid($text, 2)
      EndIf
      If FileExists($text) == 1 Then
         $SystemProgram = $text
      EndIf
   EndIf

   ; Kill it if file doesn't exists
   If FileExists($SystemProgram) <> 1 Then
      $SystemProgram = ""
   EndIf
      

   ; 2. Determin browser type.
   $type = ""
   If StringLen($SystemProgram) Then
      If StringInStr(StringUpper($SystemProgram), StringUpper($DefaultIEExe)) Then
         $type = $IniBrowserTypeMSIE
      ElseIf StringInStr(StringUpper($SystemProgram), StringUpper($DefaultFirefoxExe)) Then
         $type = $IniBrowserTypeFirefox
      Else
         $type = $IniBrowserTypeOther
      EndIf
   Else
      If $FirefoxEnable Then
         $SystemProgram = $FirefoxProgram
         $type = "Firefox"
      ElseIf $IEEnable Then
         $SystemProgram = $MSIEProgram
         $type = "MSIE"
      EndIf
   EndIf

   ; Check registry for html association
   If StringLen($type) == 0 OR $type == $IniBrowserTypeOther Then
      $regKey = "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\.html"
      $regName = ""
      $text = RegRead($regKey, $regName)
      If $text == $DefaultIEHtmlTag Then
         $type = $IniBrowserTypeMSIE
      ElseIf $text == $DefaultFirefoxHtmlTag Then
         $type = $IniBrowserTypeFirefox
      EndIf
   EndIf


   ; 3. If MSIE then
   If $type == $IniBrowserTypeMSIE Then
      ; a) If MSIE is disabled then enable it.
      If $IEEnable == 0 Then LocateMSIE($SystemProgram)

      ; b) Set data values.
      $SystemDirectory = GetDirectory($SystemProgram)
      $SystemTitle = $DefaultIETitle
      $SystemWindowCLass = $DefaultIEWindowClass
      $SystemInputID = $DefaultIEInputID
      $SystemSelectKeys = $DefaultIESelectKeys
      $SystemCopyKeys = $DefaultIECopyKeys
   EndIf


   ; 4. If Firefox then
   If $type == $IniBrowserTypeFirefox Then
      ; a) If Firefoxis disabled then enable it.
      If $FirefoxEnable == 0 Then LocateFirefox($SystemProgram)

      ; b) Set data values.
      $SystemDirectory = GetDirectory($SystemProgram)
      $SystemTitle = $DefaultFirefoxTitle
      $SystemWindowCLass = $DefaultFirefoxWindowClass
      $SystemInputID = $DefaultFirefoxInputID
      $SystemSelectKeys = $DefaultFirefoxSelectKeys
      $SystemCopyKeys = $DefaultFirefoxCopyKeys
   EndIf


   ; 5. If Other then
   If $type == $IniBrowserTypeOther Then
      ; a) Set data values.
      $SystemDirectory = GetDirectory($IEProgram)
      $SystemTitle = ""
      $SystemWindowCLass = ""
      $SystemInputID = ""
      If StringLen($SystemInputID) == 0 OR $SystemInputID == "NULL" Then
         $SystemSelectKeys = $DefaultNoInputIDSelectKeys
         $SystemCopyKeys = $DefaultNoInputIDCopyKeys
      Else
         $SystemSelectKeys = $DefaultSelectKeys
         $SystemCopyKeys = $DefaultCopyKeys
      EndIf
   EndIf


   ; 6. Exit all done.
   Return(1)
EndFunc


;
; User Defined Functions
; Miscelaneous Dialogs
;

;
; AddUrlDialog($addCat, $addName, $addUrl, $addLogin, $addPaswd, $addFlags, $addDate, $addFlag)
; Entry:       $addCat     Category to add to
;              $addName    Description to add
;              $addURL     URL to add
;              $addLogin   Login to add
;              $addPaswd   Password to add
;              $addFlags   Flags to add
;              $addDate    Date to add
;              $addFlag    0 if edit (can't change category)
;                          1 if add
; Return:      NULL  If Cancel
;              Else  Returns category URL added to
; Procedure:   1. Create the dialog.
;              2. Populate category list.
;              3. Get user inputs.
;              4. Exit if abort.
;              5. Read category items.
;              6. Verify category is legal.
;              7. Sort items and write to ini file, warn if item exists.
;              8. Write data back to ini file.
;              9. Exit all done.
;

Func  AddUrlDialog($addCat, $addName, $addUrl, $addLogin, $addPaswd, $addFlags, $addDate, $addFlag)
   Local    $dlg
   Local    $combo
   Local    $edit1, $edit2, $edit3, $edit4, $edit5, $edit6
   Local    $check1, $check2
   Local    $button1, $button2
   Local    $list, $cat, $name, $url, $login, $paswd, $flags, $date
   Local    $reply, $name2, $url2, $tabs
   Local    $notDone, $notDone2, $msg

   ; 1. Create the dialog.
   If $addFlag Then
      $dlg = GUICreate($TitleBar & $TitleAddUrl, 300, 370)
   Else
      $dlg = GUICreate($TitleBar & $TitleEditUrl, 300, 370)
   EndIf
   GUICtrlCreateLabel($TextCategory, 20, 10, 260, 20)
   $combo = GUICtrlCreateCombo($IniCatMain, 20, 30, 260, 100)
   GUICtrlCreateLabel($TextName, 20, 60, 260, 20)
   $edit1 = GUICtrlCreateInput($addName, 20, 80, 260, 20)
   GUICtrlCreateLabel($TextUrl, 20, 110, 260, 20)
   $edit2 = GUICtrlCreateInput($addUrl, 20, 130, 260, 20)
   GUICtrlCreateLabel($TextLogin, 20, 160, 200, 20)
   $login = $addLogin
   If $KeyEnable AND StringLen($login) Then $login = KeyDecode($login)
   $edit3 = GUICtrlCreateInput($login, 20, 180, 200, 20)
   GUICtrlCreateLabel($TextTabs, 235, 160, 40, 20)
   $edit4 = GUICtrlCreateInput("", 235, 180, 40, 20)
   GUICtrlCreateUpdown($edit4)
   GUICtrlCreateLabel($TextPaswd, 20, 210, 200, 20)
   $paswd = $addPaswd
   If $KeyEnable AND StringLen($paswd) Then $paswd = KeyDecode($paswd)
   $edit5 = GUICtrlCreateInput($paswd, 20, 230, 200, 20)
   GUICtrlCreateLabel($TextCR, 235, 210, 30, 20)
   $check1 = GUICtrlCreateCheckbox("", 235, 230, 30, 20)
   GUICtrlCreateLabel($TextClose, 260, 210, 30, 20)
   $check2 = GUICtrlCreateCheckbox("", 260, 230, 30, 20)
   GUICtrlCreateLabel($TextDate, 20, 260, 200, 20)
   $edit6 = GUICtrlCreateInput($addDate, 20, 280, 200, 20)
   $button1 = GUICtrlCreateButton($TextOK, 60, 320, 80, 30)
   $button2 = GUICtrlCreateButton($TextCancel, 160, 320, 80, 30)

   GUICtrlSetData($edit4, BitAND(Number($addFlags), Number($TabsMask)))
   If BitAND($addFlags, $CrFlag) Then
      GUICtrlSetState($check1, $GUI_CHECKED)
   Else
      GUICtrlSetState($check1, $GUI_UNCHECKED)
   EndIf
   If BitAND($addFlags, $CloseFlag) Then
      GUICtrlSetState($check2, $GUI_CHECKED)
   Else
      GUICtrlSetState($check2, $GUI_UNCHECKED)
   EndIf
   GUICtrlSetState($button1, $GUI_DEFBUTTON)


   ; 2. Populate category list.
   $list = BuildCategoryList($combo, $addCat)
   If $addFlag == 0 Then
      GUICtrlSetState($combo, $GUI_DISABLE)
   EndIf
   GUISetState(@SW_SHOW, $dlg)
   
   
   ; 3. Get user inputs.
   $notDone = 1
   While $notDone
      $notDone2 = 1
      While $notDone2
         $msg = GUIGetMsg()
         Select
            Case $msg == $GUI_EVENT_CLOSE
               $notDone2 = 0
            Case $msg == $button1
               $notDone2 = 0
            Case $msg == $button2
               $notDone2 = 0
         EndSelect
      WEnd
      

      ; 4. Exit if abort.
      If $msg == $button2 OR $msg == $GUI_EVENT_CLOSE Then
         GUIDelete($dlg)
         Return("")
      EndIf
      
      
      ; 5. Read items.
      $cat = GUICtrlRead($combo)
      $name = GUICtrlRead($edit1)
      $url = GUICtrlRead($edit2)
      $login = GUICtrlRead($edit3)
      If $KeyEnable AND StringLen($login) Then $login = KeyEncode($login)
      $paswd = GUICtrlRead($edit5)
      If $KeyEnable AND StringLen($paswd) Then $paswd = KeyEncode($paswd)
      $tabs = GUICtrlRead($edit4)
      $flags = $tabs
      If GUICtrlRead($check1) == $GUI_CHECKED Then $flags += $CrFlag
      If GUICtrlRead($check2) == $GUI_CHECKED Then $flags += $CloseFlag
      $date = GUICtrlRead($edit6)

      
      ; 6. Verify category is legal
      If StringInStr($cat, $RECSEP) OR StringInStr($list, $cat) == 0 Then
         MsgBox(0, $TitleBar2, "Error - Category does not exist!")
         GUICtrlSetState($combo, $GUI_FOCUS)
      ElseIf StringLen($name) == 0 Then
         MsgBox(0, $TitleBar2, "Error - Description is NULL!")
         GUICtrlSetState($edit1, $GUI_FOCUS)
      ElseIf StringLen($url) == 0 Then
         MsgBox(0, $TitleBar2, "Error - URL is NULL!")
         GUICtrlSetState($edit2, $GUI_FOCUS)
      ElseIf (StringLen($login) OR StringLen($paswd)) AND ($tabs < 0 OR $tabs > 15) Then
         MsgBox(0, $TitleBar2, "Error - Tab count must be between 0 and 15!")
         GUICtrlSetState($edit4, $GUI_FOCUS)
      Else
         If StringLen($login) == 0 AND StringLen($paswd) == 0 Then $flags = 0
         ; 7. Sort items and write to ini file, warn if item exists.
         If $addFlag Then
            $ret = AddEntryToIni($TitleBar2, $cat, $name, $url, $login, $paswd, $flags, $date, $WarnOverwriteAdd)
         Else
            $ret = EditEntryToIni($TitleBar2, $cat, $addname, $name, $url, $login, $paswd, $flags, $date, $WarnOverwriteEdit)
         EndIf
         
         If $ret <= 0 Then
            GUICtrlSetState($edit1, $GUI_FOCUS)
         Else
            $notDone = 0
         EndIf
      EndIf
      GUISetState(@SW_HIDE, $dlg)
      GUISetState(@SW_SHOW, $dlg)
   WEnd


   ; 8. Exit all done.
   GUIDelete($dlg)
   Return($cat)
EndFunc


;
; CopyUrlDialog($copyCat, $copyName, $copyUrl, $copyLogin, $copyPaswd, $copyFlags, $copyDate, $copyFlag)
; Entry:       $copyCat    Category to copy from
;              $copyName   Description to copy
;              $copyURL    URL to copy
;              $addLogin   Login to copy
;              $addPaswd   Password to copy
;              $addFlags   Flags to copy
;              $addDate    Date to copy
;              $copyFlag   0 if move
;                          1 if copy
; Return:      NULL  If Cancel
;              Else  Returns category URL copied/moved to
; Procedure:   1. Create the dialog.
;              2. Populate category list.
;              3. Get user inputs.
;              4. Exit if abort.
;              5. Can't have the same source and target.
;              6. Sort items and write to ini file, warn if item exists.
;              7. Exit all done.
;

Func  CopyUrlDialog($copyCat, $copyName, $copyUrl, $copyLogin, $copyPaswd, $copyFlags, $copyDate, $copyFlag)
   Local    $dlg
   Local    $combo1, $combo2
   Local    $button1, $button2
   Local    $list, $reply, $cat2
   Local    $notDone, $notDone2, $msg
   
   ; 1. Create the dialog.
   If $copyFlag Then
      $dlg = GUICreate($TitleBar & $TitleCopyUrl, 300, 170)
   Else
      $dlg = GUICreate($TitleBar & $TitleMoveUrl, 300, 170)
   EndIf
   GUICtrlCreateLabel($TextSCategory, 20, 10, 260, 20)
   $combo1 = GUICtrlCreateCombo($IniCatMain, 20, 30, 260, 100)
   GUICtrlCreateLabel($TextTCategory, 20, 60, 260, 20)
   $combo2 = GUICtrlCreateCombo($IniCatMain, 20, 80, 260, 100)
   $button1 = GUICtrlCreateButton($TextOK, 60, 120, 80, 30)
   GUICtrlSetState($button1, $GUI_DEFBUTTON)
   $button2 = GUICtrlCreateButton($TextCancel, 160, 120, 80, 30)


   ; 2. Populate category list.
   $list = BuildCategoryList($combo1, $copyCat)
   $list = BuildCategoryList($combo2, $IniCatMain)
   GUICtrlSetState($combo1, $GUI_DISABLE)
   GUISetState(@SW_SHOW, $dlg)
   
   
   ; 3. Get user inputs.
   $notDone = 1
   While $notDone
      $notDone2 = 1
      While $notDone2
         $msg = GUIGetMsg()
         Select
            Case $msg == $GUI_EVENT_CLOSE
               $notDone2 = 0
            Case $msg == $button1
               $notDone2 = 0
            Case $msg == $button2
               $notDone2 = 0
         EndSelect
      WEnd
      

      ; 4. Exit if abort.
      If $msg == $button2 OR $msg == $GUI_EVENT_CLOSE Then
         GUIDelete($dlg)
         Return("")
      EndIf
      
      
      ; 5. Can't have the same source and target.
      $cat2 = GUICtrlRead($combo2)
      If $cat2 == $copyCat Then
         MsgBox(0, $TitleBar2, "Error - Source and target categories may not be the same!")
         GUICtrlSetState($combo2, $GUI_FOCUS)
      Else
         ; 6. Sort items and write to ini file, warn if item exists.
         If $copyFlag Then
            $ret = AddEntryToIni($TitleBar2, $cat2, $copyName, $copyUrl, $copyLogin, $copyPaswd, $copyFlags, $copyDate, $WarnOverwriteCopy)
            If $ret Then
               DelEntryFromIni($TitleBar2, $copyCat, $copyName, 0)
            EndIf
         Else
            $ret = AddEntryToIni($TitleBar2, $cat2, $copyName, $copyUrl, $copyLogin, $copyPaswd, $copyFlags, $copyDate, $WarnOverwriteMove)
         EndIf
         
         If $ret <= 0 Then
            GUICtrlSetState($combo2, $GUI_FOCUS)
         Else
            $notDone = 0
         EndIf
      EndIf

      GUISetState(@SW_ENABLE, $dlg)
      GUISetState(@SW_HIDE, $dlg)
      GUISetState(@SW_SHOW, $dlg)
   WEnd


   ; 7. Exit all done.
   GUIDelete($dlg)
   Return($cat2)
EndFunc


;
; User Defined Functions
; Macro Functions
;

; MacroDecode - Convert to system directories
;
; Input:        $value      String to convert
; Return:       $value      Converted string
; Procedure:    1. Convert all macro tags
;               2. Return converted string
; Allowable macro values:
;               <<<CommonFiles>>>
;                   Path to Common Files folder 
;               <<<ProgramFiles>>>
;                   Path to Program Files folder 
;               <<<WindowsDir>>>
;                   Path to Windows folder 
;               <<<SystemDir>>>
;                   Path to System folder 
;
Func    MacroDecode($value)
   Local    $ls
   Local    $rs
   Local    $pos
   Local    $notdone

; 1. Convert all macro tags
   $rs = $value
   $notdone = 1
   While $notdone
      $ls = ""
      While StringLen($rs)
         If StringInStr($rs, $MacroCommonFiles, 1) Then
            $pos = StringInStr($rs, $MacroCommonFiles, 1)
            $ls = $ls & StringLeft($rs, $pos - 1) & @CommonFilesDir
            $rs = StringMid($rs, $pos + StringLen($MacroCommonFiles))
         ElseIf StringInStr($rs, $MacroProgramFiles, 1) Then
            $pos = StringInStr($rs, $MacroProgramFiles, 1)
            $ls = $ls & StringLeft($rs, $pos - 1) & @ProgramFilesDir
            $rs = StringMid($rs, $pos + StringLen($MacroProgramFiles))
         ElseIf StringInStr($rs, $MacroWindowsDir, 1) Then
            $pos = StringInStr($rs, $MacroWindowsDir, 1)
            $ls = $ls & StringLeft($rs, $pos - 1) & @WindowsDir
            $rs = StringMid($rs, $pos + StringLen($MacroWindowsDir))
         ElseIf StringInStr($rs, $MacroSystemDir, 1) Then
            $pos = StringInStr($rs, $MacroSystemDir, 1)
            $ls = $ls & StringLeft($rs, $pos - 1) & @SystemDir
            $rs = StringMid($rs, $pos + StringLen($MacroSystemDir))
         Else
            If  StringLen($ls) == 0 Then
               $notdone = 0
            EndIf

            $ls = $ls & $rs
            $rs = ""
         EndIf
       WEnd
      If  StringLen($ls) == 0 Then
         $notdone = 0
      EndIf
      $rs = $ls
    WEnd

; 2. Return converted string
    Return($ls)
EndFunc



; MacroEncode - Convert from system directories
;
; Input:        $value      String to convert
; Return:       $value      Converted string
; Procedure:    1. Convert all system directories
;               2. Return converted string
; Allowable macro values:
;               <<<FlashRunnerCommonFilesDir>>>
;                   Path to Common Files folder 
;               <<<FlashRunnerProgramFilesDir>>>
;                   Path to Program Files folder 
;               <<<FlashRunnerSystemDir>>>
;                   Path to System folder 
;               <<<FlashRunnerWindowsDir>>>
;                   Path to Windows folder 
;
Func  MacroEncode($value)
   Local    $text
   Local    $text1
   Local    $text2
   Local    $text3
   Local    $pos
   Local    $len
   Local    $tag
   Local    $separator
   Local    $notdone

   ; 1. Convert all system directories
   $text = StringUpper($value)
   $text1 = $value
   $notdone = 1
   While $notdone
      $separator = 1
      If StringInStr($text, StringUpper(@CommonFilesDir)) Then
         $pos = StringInStr($text, StringUpper(@CommonFilesDir))
         $len = StringLen(@CommonFilesDir)
         $tag = $MacroCommonFiles
      ElseIf StringInStr($text, StringUpper(@ProgramFilesDir)) Then
         $pos = StringInStr($text, StringUpper(@ProgramFilesDir))
         $len = StringLen(@ProgramFilesDir)
         $tag = $MacroProgramFiles
      ElseIf StringInStr($text, StringUpper(@SystemDir)) Then
         $pos = StringInStr($text, StringUpper(@SystemDir))
         $len = StringLen(@SystemDir)
         $tag = $MacroSystemDir
      ElseIf StringInStr($text, StringUpper(@WindowsDir)) Then
         $pos = StringInStr($text, StringUpper(@WindowsDir))
         $len = StringLen(@WindowsDir)
         $tag = $MacroWindowsDir
      Else
         $notdone = 0
      EndIf
      
      If $notdone Then
         $text2 = StringLeft($text, $pos - 1)
         $text2 = $Text2 & $tag
         $text3 = StringLeft($text1, $pos - 1)
         $text3 = $Text3 & $tag
         $text = StringMid($text, $pos + $len)
         $text1 = StringMid($text1, $pos + $len)

         $text = $text2 & $text
         $text1 = $text3 & $text1
      EndIf
   WEnd

   ; 2. Return converted string
   Return($text1)
EndFunc


;
; User Defined Functions
; Key Coding Functions
;

; CheckMain - Make sure main code is loaded
;
; Input:       <None>
; Return:      0 if fail
;              1 if ok
; Procedure:   1. If main not loaded, then fail.
;              2. Return all ok.
;
Func  CheckMain()
   ; 1. If main not loaded then fail.
   If @Compiled Then
      If ProcessExists($KeyProgram) == 0 Then
         Return(0)
      EndIf
   EndIf


   ; 2. Return all ok.
   Return(1)
EndFunc


; EnableKeyCoding - Enable key encoding
;
; Input:       <None>
; Return:      1 if all ok
;              0 if user abort
; Procedure:   1. Display info message.
;              2. Get key from user, exit if user abort.
;              3. Get confirmation from user, exit if user abort.
;              4. Error if keys don't match.
;              5. Encode existing login & password info.
;              6. Exit all done.
;
Func  EnableKeyCoding()
   Local    $msg, $msg2, $notDone
   Local    $cat, $items, $items2, $index, $index2
   Local    $record = CreateRecord("","","","",0,"")

   ; 1. Display info message.
   $msg = "IMPORTANT!  You have elected to protect your web site login and password" & @CRLF
   $msg &= "information with a key code.  This will result in protecting your information should" & @CRLF
   $msg &= "you ever lose your flash drive or should it ever be stolen." & @CRLF & @CRLF
   $msg &= "It is important to note that your key code will not be stored on this computer" & @CRLF
   $msg &= "nor anywhere else.  Should you forget your key code it will not be possible to" & @CRLF
   $msg &= "recover your information and you will have to delete the information and reenter" & @CRLF
   $msg &= "it." & @CRLF & @CRLF
   $msg &= "Proceed with your key code selection now?" & @CRLF
   If MsgBox(260, $TitleBar2, $msg) <> 6 Then Return(0)


   ; 2. Get key from user, exit if user abort.
   $notDone = 1
   While $notDone
      $msg = InputBox($TitleBar2, "Please enter your key code (6-16 characters):", "", "*", 300, 120)
      If @error Then Return(0)


      ; 3. Get confirmation from user, exit if user abort.
      If StringLen($msg) >= 6 AND StringLen($msg) <= 16 Then
         $msg2 = InputBox($TitleBar2, "Please reenter your key code:", "", "*", 300, 120)
         If @error Then Return(0)

         If $msg <> $msg2 Then
            ; 4. Error if keys don't match.
            MsgBox(0, $TitleBar2, "Error - Key codes do not match.")
         Else
            $notDone = 0
         EndIf
      Else
         MsgBox(0, $TitleBar2, "Error - Key code must be between 6 and 16 characters.")
      EndIf
   WEnd


   ; 5. Encode existing login & password info.
   SplashTextOn($TitleBar2, @CRLF & @CRLF & "One moment please...", 240, 120, -1, -1, 18)
   $KeyCode = $msg
   $items = Number(IniRead($IniFile, $IniCatSection, $IniItems, 0))
   $index = 0
   While $index <= $items
      If $index == 0 Then
         $cat = $IniCatMain
      Else
         $cat = IniRead($IniFile, $IniCatSection, $IniItem & $index, "")
      EndIf

      $items2 = Number(IniRead($IniFile, $cat, $IniItems, 0))
      If $items2 Then
         $index2 = 1
         While $index2 <= $items2
            ; Read next item
            $record = ReadRecordByIndex($TitleBar2, $cat, $index2)
   
            ; Encrypt and write it out if not blank
            If StringLen($record[$RECLOGIN]) OR StringLen($record[$RECPASWD]) Then
               If StringLen($record[$RECLOGIN]) Then
                  $record[$RECLOGIN] = KeyEncode($record[$RECLOGIN])
               EndIf
         
               If StringLen($record[$RECPASWD]) Then
                  $record[$RECPASWD] = KeyEncode($record[$RECPASWD])
               EndIf
         
               WriteRecordByIndex($TitleBar2, $cat, $index2, $record)
            EndIf
            $index2 += 1
         WEnd
      EndIf
      $index += 1
   WEnd
   SplashOff() 


   ; 6. Exit all done.
   Return(1)
EndFunc


; DisableKeyCoding - Disable key encoding
;
; Input:       <None>
; Return:      1 if all ok
;              0 if user abort
; Procedure:   1. Display info message.
;              2. Decode existing login & password info.
;              3. Exit all done.
;
Func  DisableKeyCoding()
   Local    $msg
   Local    $cat, $items, $items2, $index, $index2
   Local    $record = CreateRecord("","","","",0,"")

   ; 1. Display info message.
   $msg = "IMPORTANT!  You have elected to disable the encoding of your web site login and" & @CRLF
   $msg &= "password information.  Your data will now be stored unencrypted in standard english." & @CRLF
   $msg &= "Should you lose your flash drive or should it ever be stolen, the data will be readily" & @CRLF
   $msg &= "available to whoever finds it." & @CRLF & @CRLF
   $msg &= "Proceed with the key coding removal now?" & @CRLF
   If MsgBox(260, $TitleBar2, $msg) <> 6 Then Return(0)


   ; 2. Decode existing login & password info.
   If StringLen($KeyCode) == 0 Then
      $KeyCode = InputBox($TitleBar2, "Please enter your key code:", "", "*", 300, 120)
      If @error Then Return(0)
   EndIf

   SplashTextOn($TitleBar2, @CRLF & @CRLF & "One moment please...", 240, 120, -1, -1, 18)
   $items = Number(IniRead($IniFile, $IniCatSection, $IniItems, 0))
   $index = 0
   While $index <= $items
      If $index == 0 Then
         $cat = $IniCatMain
      Else
         $cat = IniRead($IniFile, $IniCatSection, $IniItem & $index, "")
      EndIf

      $items2 = Number(IniRead($IniFile, $cat, $IniItems, 0))
      If $items2 Then
         $index2 = 1
         While $index2 <= $items2
            ; Read next item
            $record = ReadRecordByIndex($TitleBar2, $cat, $index2)
   
            ; Decrypt and write it out if not blank
            If StringLen($record[$RECLOGIN]) OR StringLen($record[$RECPASWD]) Then
               If StringLen($record[$RECLOGIN]) Then
                  $record[$RECLOGIN] = KeyDecode($record[$RECLOGIN])
               EndIf
         
               If StringLen($record[$RECPASWD]) Then
                  $record[$RECPASWD] = KeyDecode($record[$RECPASWD])
               EndIf
         
               WriteRecordByIndex($TitleBar2, $cat, $index2, $record)
            EndIf
            $index2 += 1
         WEnd
      EndIf
      $index += 1
   WEnd
   SplashOff()
   For $index = 0 To 17
      $KeyCode[$index] = 0
   Next
   $KeyTimer = 0


   ; 6. Exit all done.
   Return(1)
EndFunc


; KeyEncode - Encode key information
;
; Input:       $text          Text to encode
; Return:      $code          Encoded text
;              NULL if failure
; Procedure:   1. If main not loaded, then attempt to load it.
;              2. Return NULL if program not found.
;              3. Encode the text.
;              4. Return data.
;
Func  KeyEncode($text)
   Local    $program, $timetag, $result

   ; 1. If main not loaded then attempt to load it.
   AutoItSetOption("RunErrorsFatal", 0)
   AutoItSetOption("WinTitleMatchMode", 3)

   If WinExists($TitleBar & $TitleMain, $TitleAuthor) == 0 Then
      $program = @ScriptDir
      If StringRight($program, 1) == "\" Then
         $program &= $KeyProgram
      Else
         $program &= "\" & $KeyProgram
      EndIf
      Run($program, @ScriptDir)


      ; 2. Return NULL if program not found.
      If WinWait($TitleBar & $TitleMain, $TitleAuthor, 5) == 0 Then
         MsgBox(0, $TitleBar2, "Error - Encoder not present!")
         Return("")
      EndIf
   EndIf


   ; 3. Encode the text.
   If StringLen($KeyCode) == 0 Then
      $KeyCode = InputBox($TitleBar2, "Please enter your key code:", "", "*", 300, 120)
      If @error Then Return(0)
   EndIf

   ControlSetText($TitleBar & $TitleMain, $TitleAuthor, $KeySource, $text)
   ControlSetText($TitleBar & $TitleMain, $TitleAuthor, $KeyKey, $KeyCode)
   ControlClick($TitleBar & $TitleMain, $TitleAuthor, $KeyEncode)

   $result = "1"
   $timetag = TimerInit()
   While StringLen($result)
      $result = ControlGetText($TitleBar & $TitleMain, $TitleAuthor, $KeyKey)
      If @error Then $result1 = ""
      If TimerDiff($timetag) > 5000 Then $result = ""
   WEnd

   $timetag = TimerInit()
   While StringLen($result) == 0
      $result = ControlGetText($TitleBar & $TitleMain, $TitleAuthor, $KeyResult)
      If @error Then $result = ""
      If TimerDiff($timetag) > 5000 Then
         MsgBox(0, $TitleBar2, "Error - Key encode failed!")
         Return("")
      EndIf
   WEnd
   

   ; 4. Return data.
   Return($result)
EndFunc


; KeyDecode - Decode key information
;
; Input:       $text          Text to decode
; Return:      $code          Decoded text
;              NULL if failure
; Procedure:   1. If main not loaded, then attempt to load it.
;              2. Return NULL if program not found.
;              3. Decode the text.
;              4. Return data.
;
Func  KeyDecode($text)
   Local    $program, $timetag, $result

   ; 1. If main not loaded then attempt to load it.
   AutoItSetOption("RunErrorsFatal", 0)
   AutoItSetOption("WinTitleMatchMode", 3)

   If WinExists($TitleBar & $TitleMain, $TitleAuthor) == 0 Then
      $program = @ScriptDir
      If StringRight($program, 1) == "\" Then
         $program &= $KeyProgram
      Else
         $program &= "\" & $KeyProgram
      EndIf
      Run($program, @ScriptDir)

      ; 2. Return NULL if program not found.
      If WinWait($TitleBar & $TitleMain, $TitleAuthor, 5) == 0 Then
         MsgBox(0, $TitleBar2, "Error - Decoder not present!")
         Return("")
      EndIf
   EndIf


   ; 3. Decode the text.
   If StringLen($KeyCode) == 0 Then
      $KeyCode = InputBox($TitleBar2, "Please enter your key code:", "", "*", 300, 120)
      If @error Then Return(0)
   EndIf
   
   ControlSetText($TitleBar & $TitleMain, $TitleAuthor, $KeySource, $text)
   ControlSetText($TitleBar & $TitleMain, $TitleAuthor, $KeyKey, $KeyCode)
   ControlClick($TitleBar & $TitleMain, $TitleAuthor, $KeyDecode)

   $result = "1"
   $timetag = TimerInit()
   While StringLen($result)
      $result = ControlGetText($TitleBar & $TitleMain, $TitleAuthor, $KeyKey)
      If @error Then $result1 = ""
      If TimerDiff($timetag) > 5000 Then $result = ""
   WEnd

   $timetag = TimerInit()
   While StringLen($result) == 0
      $result = ControlGetText($TitleBar & $TitleMain, $TitleAuthor, $KeyResult)
      If @error Then $result = ""
      If TimerDiff($timetag) > 5000 Then
         MsgBox(0, $TitleBar2, "Error - Key decode failed!")
         Return("")
      EndIf
   WEnd
   

   ; 4. Return data.
   Return($result)
EndFunc


;
; User Defined Functions
; Miscelaneous Functions
;

; GetDirectory - Extract directory from filename
;
; Input:       $filename      Filename to extract directory from
; Return:      $directory     Directory name
; Procedure:   1. Return NULL if source is NULL
;              2. Return NULL if no "\" in string.
;              3. Extarct directory name.
;              4. Append "\" if it is a root directory.
;              5. Return directory string
;
Func  GetDirectory($filename)
   Local    $dir
   
   ; 1. Return NULL if source is NULL
   If StringLen($filename) == 0 Then Return("")

   ; 2. Return NULL if no "\" in string.
   If StringInStr($filename, "\") == 0 Then Return("")

   ; 3. Extarct directory name.
   $dir = StringLeft($filename, StringInStr($filename, "\", 0, -1) - 1)

   ; 4. Append "\" if it is a root directory.
   If StringLen($dir) == 2 AND StringRight($dir, 1) == ":" Then
      $dir = $dir & "\"
   EndIf

   ; 5. Return directory string.
   Return($dir)
EndFunc


; GetDateStr - Return a date & time string
;
; Input:       <None>
; Return:      $datestr       Date & time string
; Procedure:   1. Build the string.
;              2. Return it.
;
Func  GetDateStr()
   Local    $str, $hour, $min

   ; 1. Build the string.
   $str = @MON & "/" & @MDAY & "/" & @YEAR & " at "
   $hour = @HOUR
   $min = @MIN
   If $hour == 0 Then
      $str &= "12:" & $min & " AM"
   ElseIf $hour < 12 Then
      $str &= $hour & ":" & $min & " AM"
   Else
      $str &= ($hour - 12) & ":" & $min & " PM"
   EndIf

   ; 2. Return it
   Return($str)
EndFunc

